Attribute VB_Name = "CommonControlDeclarations"
Option Explicit

'==================================================================
'
' Common Control Declarations
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================


'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?

'------------------------------------------------------------------------
' Declarations

Public Declare Sub InitCommonControls Lib "Comctl32.dll" ()
Public Declare Function InitCommonControlsEx Lib "Comctl32.dll" (iccex As tagInitCommonControlsEx) As Boolean

Public Enum CommonControlClassTypes
  ICC_LISTVIEW_CLASSES = &H1
  ICC_TREEVIEW_CLASSES = &H2        ' treeview, tooltips
  ICC_BAR_CLASSES = &H4             ' toolbar, statusbar, trackbar, tooltips
  ICC_TAB_CLASSES = &H8             ' tab, tooltips
  ICC_UPDOWN_CLASS = &H10           ' updown
  ICC_PROGRESS_CLASS = &H20         ' progress
  ICC_HOTKEY_CLASS = &H40           ' hotkey
  ICC_ANIMATE_CLASS = &H80          ' animate
  ICC_WIN95_CLASSES = &HFF
  ICC_DATE_CLASSES = &H100          ' month picker, date picker, time picker, updown
  ICC_USEREX_CLASSES = &H200        ' comboex
  ICC_COOL_CLASSES = &H400          ' rebar (coolbar) control
#If (WIN32_IE >= IE4) Then
  ICC_INTERNET_CLASSES = &H800
  ICC_PAGESCROLLER_CLASS = &H1000   ' page scroller
  ICC_NATIVEFNTCTL_CLASS = &H2000   ' native font control
#End If ' IE4
End Enum

Public Enum CommonControlMessages
  CCM_FIRST = &H2000                       ' Common control shared messages
  CCM_LAST = (CCM_FIRST + &H200)
  CCM_SETBKCOLOR = (CCM_FIRST + 1)         ' lParam is bkColor
  
  CCM_SETCOLORSCHEME = (CCM_FIRST + 2)     ' lParam is color scheme
  CCM_GETCOLORSCHEME = (CCM_FIRST + 3)     ' fills in COLORSCHEME pointed to by lParam
  CCM_GETDROPTARGET = (CCM_FIRST + 4)
  CCM_SETUNICODEFORMAT = (CCM_FIRST + 5)
  CCM_GETUNICODEFORMAT = (CCM_FIRST + 6)
  
#If (WIN32_IE >= IE5) Then
  CCM_SETVERSION = (CCM_FIRST + &H7)
  CCM_GETVERSION = (CCM_FIRST + &H8)
  CCM_SETNOTIFYWINDOW = (CCM_FIRST + &H9)  ' wParam == hwndParent.
#End If ' IE5
End Enum

Public Enum CommonControlNotifications
  NM_FIRST = -0    ' generic to all controls
  NM_LAST = -99
  LVN_FIRST = -100 ' listview
  LVN_LAST = -199
  PSN_FIRST = -200 ' Property Sheet
  PSN_LAST = -299
  HDN_FIRST = -300 ' header
  HDN_LAST = -399
  TVN_FIRST = -400 ' treeview
  TVN_LAST = -499
  TTN_FIRST = -520 ' tooltips
  TTN_LAST = -549
  TCN_FIRST = -550 ' tab control
  TCN_LAST = -580
  SRN_FIRST = -580 ' Shell reserved
  SRN_LAST = -589
  CDN_FIRST = -601 ' common dialog
  CDN_LAST = -699
  TBN_FIRST = -700 ' toolbar
  TBN_LAST = -720
  UDN_FIRST = -721 ' updown
  UDN_LAST = -740
#If (WIN32_IE >= IE3) Then
  MCN_FIRST = -750 ' monthcal
  MCN_LAST = -759
  DTN_FIRST = -760 ' datetimepick
  DTN_LAST = -799
  CBEN_FIRST = -800 ' combo box ex
  CBEN_LAST = -830
  RBN_FIRST = -831  ' rebar
  RBN_LAST = -859
#End If ' IE3
#If (WIN32_IE >= IE4) Then
  IPN_FIRST = -860  ' internet address
  IPN_LAST = -879   ' internet address
  SBN_FIRST = -880  ' status bar
  SBN_LAST = -899
  PGN_FIRST = -900  ' Pager Control
  PGN_LAST = -950
#End If ' IE4
#If (WIN32_IE >= IE5) Then
  WMN_FIRST = -1000
  WMN_LAST = -1200
#End If ' IE5
  
  NM_OUTOFMEMORY = (NM_FIRST - 1)
  NM_CLICK = (NM_FIRST - 2)
  NM_DBLCLK = (NM_FIRST - 3)
  NM_RETURN = (NM_FIRST - 4)
  NM_RCLICK = (NM_FIRST - 5)
  NM_RDBLCLK = (NM_FIRST - 6)
  NM_SETFOCUS = (NM_FIRST - 7)
  NM_KILLFOCUS = (NM_FIRST - 8)
#If (WIN32_IE >= IE3) Then
  NM_CUSTOMDRAW = (NM_FIRST - 12)
  NM_HOVER = (NM_FIRST - 13)
#End If ' IE3
#If (WIN32_IE >= IE4) Then
  NM_NCHITTEST = (NM_FIRST - 14)
  NM_KEYDOWN = (NM_FIRST - 15)
  NM_RELEASEDCAPTURE = (NM_FIRST - 16)
  NM_SETCURSOR = (NM_FIRST - 17)
  NM_CHAR = (NM_FIRST - 18)
#End If ' IE4
#If (WIN32_IE >= IE401) Then
  NM_TOOLTIPSCREATED = (NM_FIRST - 19)
#End If ' IE401
#If (WIN32_IE >= IE5) Then
  NM_LDOWN = (NM_FIRST - 20)
  NM_RDOWN = (NM_FIRST - 21)
#End If ' IE5
End Enum

Public Enum CommonControlsStyles
  CCS_TOP = &H1&
  CCS_NOMOVEY = &H2&
  CCS_BOTTOM = &H3&
  CCS_NORESIZE = &H4&
  CCS_NOPARENTALIGN = &H8
  CCS_NOHILITE = &H10&
  CCS_ADJUSTABLE = &H20&
  CCS_NODIVIDER = &H40&
#If (WIN32_IE >= IE3) Then
  CCS_VERT = &H80
  CCS_LEFT = (CCS_VERT Or CCS_TOP)
  CCS_RIGHT = (CCS_VERT Or CCS_BOTTOM)
  CCS_NOMOVEX = (CCS_VERT Or CCS_NOMOVEY)
#End If
End Enum

#If (WIN32_IE >= IE3) Then
  ' values under &H00010000 are reserved for global use
  Public Enum CommonControlCustomRedrawReturnFlags
    CDRF_DODEFAULT = &H0
    CDRF_NEWFONT = &H2
    CDRF_SKIPDEFAULT = &H4
    CDRF_NOTIFYPOSTPAINT = &H10
    CDRF_NOTIFYITEMDRAW = &H20
#If (WIN32_IE >= IE4) Then
    CDRF_NOTIFYSUBITEMDRAW = &H20        ' flags are the same, we can distinguish by context
#End If
    CDRF_NOTIFYPOSTERASE = &H40
  End Enum
  
  ' values under &H00010000 are reserved for global use
  Public Enum CommonControlCustomRedrawDrawStateFlags
    CDDS_PREPAINT = &H1
    CDDS_POSTPAINT = &H2
    CDDS_PREERASE = &H3
    CDDS_POSTERASE = &H4
    
    CDDS_ITEM = &H10000 ' the=&H000010000 bit means it's individual item specific
    CDDS_ITEMPREPAINT = (CDDS_ITEM Or CDDS_PREPAINT)
    CDDS_ITEMPOSTPAINT = (CDDS_ITEM Or CDDS_POSTPAINT)
    CDDS_ITEMPREERASE = (CDDS_ITEM Or CDDS_PREERASE)
    CDDS_ITEMPOSTERASE = (CDDS_ITEM Or CDDS_POSTERASE)
#If (WIN32_IE >= IE4) Then
    CDDS_SUBITEM = &H20000
#End If
  End Enum
  
  ' values under &H00010000 are reserved for global use
  Public Enum CommonControlCustomRedrawItemStates
    CDIS_SELECTED = &H1
    CDIS_GRAYED = &H2
    CDIS_DISABLED = &H4
    CDIS_CHECKED = &H8
    CDIS_FOCUS = &H10
    CDIS_DEFAULT = &H20
    CDIS_HOT = &H40
    CDIS_MARKED = &H80
    CDIS_INDETERMINATE = &H100
  End Enum
  
  Public Type NMCUSTOMDRAW
    hdr As NMHDR
    dwDrawStage As Long  ' CommonControlCustomRedrawDrawStateFlags enum
    hDC As Long
    rc As RECT
    dwItemSpec As Long   ' this is control specific, but it's how to specify an item.  valid only with CDDS_ITEM bit set
    uItemState As Long   ' CommonControlCustomRedrawItemStates enum
    lItemlParam As Long
  End Type
  
  Public Type NMTTCUSTOMDRAW
    nmcd As NMCUSTOMDRAW
    uDrawFlags As Long
  End Type
#End If

Public Type tagInitCommonControlsEx
  lngSize As Long
  lngICC As Long
End Type

#If (WIN32_IE >= IE4) Then
'  Public Type NMTTDISPINFO
'    hdr As NMHDR
'    lpszText As Long
'    szText(0 To 79) As Byte
'    hInst As Long
'    uFlags As Long
'    lParam As Long
'  End Type
  
  Public Type NMMOUSE
    hdr As NMHDR
    dwItemSpec As Long
    dwItemData As Long
    pt As POINTAPI
    dwHitInfo As Long
  End Type
  
  Public Type NMKEY
    hdr As NMHDR
    nVKey As Long
    uFlags As Long
  End Type
  
  Public Type NMCHAR
    hdr As NMHDR
    ch As Long
    dwItemPrev As Long
    dwItemNext As Long
  End Type
  
  Public Type NMOBJECTNOTIFY
    hdr As NMHDR
    iItem As Long
    piid As Long    ' GUID? (substructure is properly long-pointer)
    pObject As Long ' Actually Object, but that errors if VB didn't add reference count
    hResult As Long
    dwFlags As Long ' control specific flags (hints as to where in iItem it hit)
  End Type
  
  Public Type COLORSCHEME
    dwSize As Long
    clrBtnHighlight As Long
    clrBtnShadow As Long
  End Type
#End If

#If (WIN32_IE >= IE401) Then
  Public Type NMTOOLTIPSCREATED
    hdr As NMHDR
    hwndToolTips As Long
  End Type
#End If ' IE401

#If (WIN32_IE >= IE4) Then
  Public Property Get CommonControls_ColorScheme(ByVal hWndCtl As Long) As COLORSCHEME
    CommonControls_ColorScheme.dwSize = LenB(CommonControls_ColorScheme)
    If SendMessage(hWndCtl, CCM_GETCOLORSCHEME, 0, CommonControls_ColorScheme) = 0 Then Error 383
  End Property
  
  Public Property Let CommonControls_ColorScheme(ByVal hWndCtl As Long, NewValue As COLORSCHEME)
    NewValue.dwSize = LenB(NewValue)
    Call SendMessage(hWndCtl, CCM_SETCOLORSCHEME, 0, NewValue)
  End Property
#End If
