Attribute VB_Name = "GeneralCoolBarDeclarations"
Option Explicit

'==================================================================
'
' Coolbar Declarations
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================


'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?

Public Const OBJPTR_BASE = 10000 ' Pointers below this value won't be accepted.
Public Const IDGEN_RANGE = &H1000&
Public Const IDGEN_MAX = &H7FFF& ' Max Int

Public Const BUTTON_IDGEN_BASE = &H6000&
Public Const BUTTON_IDGEN_MAX = BUTTON_IDGEN_BASE + IDGEN_RANGE - 1
Public Const MENU_IDGEN_BASE = BUTTON_IDGEN_BASE + IDGEN_RANGE
Public Const MENU_IDGEN_MAX = MENU_IDGEN_BASE + IDGEN_RANGE - 1

Public Const COOLBAR_STORAGE_ID = "ButtonCls="


'------------------------------------------------------------------------
' Declarations

Public Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Public Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long

Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As GetWindowLongFlags) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As GetWindowLongFlags, ByVal dwNewLong As Long) As Long

Public Declare Function EnableWindow Lib "user32" (ByVal hWnd As Long, ByVal fEnable As Long) As Long
Public Declare Function IsWindowEnabled Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetForegroundWindow Lib "user32" () As Long

Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As SetWindowPosFlags) As Long
Public Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Public Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function MapWindowPoints Lib "user32" (ByVal hWndFrom As Long, ByVal hWndTo As Long, lppt As Any, ByVal cPoints As Long) As Long

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Public Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long

Public Declare Function UpdateWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function LockWindowUpdate Lib "user32" (ByVal hWndLock As Long) As Long

Public Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Public Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long
Public Declare Function ClientToScreen Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (DestPtr As Any, SourcePtr As Any, ByVal NumOfBytes As Long)
Public Declare Function OleTranslateColor Lib "olepro32" (ByVal OLE_COLOR As Long, ByVal hPalette As Long, pProgressBar_CColorref As Long) As Long
Public Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (lpPictDesc As PictDesc, riid As GUID, ByVal fPictureOwnsHandle As Long, ipic As IPicture) As Long
Public Const CLR_INVALID = -1

Public Declare Function IsTextUnicode Lib "advapi32" (lpBuffer As Any, ByVal cb As Long, ByVal lpi As IsTextUnicodeFlags) As Long


Public Enum CoolbarMessages
  WM_SIZE = &H5
  WM_PAINT = &HF
  WM_ERASEBKGND = &H14
  WM_SYSCOLORCHANGE = &H15
  WM_CHILDACTIVATE = &H22
  WM_GETMINMAXINFO = &H24
  WM_NOTIFY = &H4E&
  WM_COMMAND = &H111
  
  WM_KEYDOWN = &H100
  WM_KEYUP = &H101
  
  WM_CANCELMODE = &H1F
  WM_MOUSEMOVE = &H200
  
  WM_LBUTTONDOWN = &H201
  WM_LBUTTONUP = &H202
  
  WM_USER = &H400
End Enum

Public Enum CoolBarStyles
  WS_BORDER = &H800000
  WS_THICKFRAME = &H400000
  WS_CLIPCHILDREN = &H2000000
  WS_CLIPSIBLINGS = &H4000000
  WS_CHILD = &H40000000
End Enum

Public Enum CoolBarExStyles
  WS_EX_TOOLWINDOW = &H80&
  WS_EX_CLIENTEDGE = &H200&     ' Window Extended Style: Thin Edge
  WS_EX_STATICEDGE = &H20000    ' Window Extended Style: 3D Frame
End Enum

Public Enum GetWindowLongFlags
  GWL_STYLE = (-16)
  GWL_EXSTYLE = (-20)
End Enum

Public Enum SetWindowPosFlags
  SWP_FRAMECHANGED = &H20
  SWP_NOACTIVATE = &H10
  SWP_NOMOVE = &H2
  SWP_NOSIZE = &H1
  SWP_SHOWWINDOW = &H40
  SWP_HIDEWINDOW = &H80
  SWP_NOCOPYBITS = &H100
  SWP_NOOWNERZORDER = &H200
  SWP_NOREDRAW = &H8
  SWP_NOZORDER = &H4
  SWP_DRAWFRAME = SWP_FRAMECHANGED
  SWP_NOREPOSITION = SWP_NOOWNERZORDER
End Enum

Public Enum IsTextUnicodeFlags
  IS_TEXT_UNICODE_ASCII16 = &H1
  IS_TEXT_UNICODE_REVERSE_ASCII16 = &H10
  IS_TEXT_UNICODE_STATISTICS = &H2
  IS_TEXT_UNICODE_REVERSE_STATISTICS = &H20
  IS_TEXT_UNICODE_CONTROLS = &H4
  IS_TEXT_UNICODE_REVERSE_CONTROLS = &H40
  IS_TEXT_UNICODE_SIGNATURE = &H8
  IS_TEXT_UNICODE_REVERSE_SIGNATURE = &H80
  IS_TEXT_UNICODE_ILLEGAL_CHARS = &H100
  IS_TEXT_UNICODE_ODD_LENGTH = &H200
  IS_TEXT_UNICODE_DBCS_LEADBYTE = &H400
  IS_TEXT_UNICODE_NULL_BYTES = &H1000
  IS_TEXT_UNICODE_UNICODE_MASK = &HF
  IS_TEXT_UNICODE_REVERSE_MASK = &HF0
  IS_TEXT_UNICODE_NOT_UNICODE_MASK = &HF00
  IS_TEXT_UNICODE_NOT_ASCII_MASK = &HF000
End Enum

Public Type NMHDR
  hWndFrom As Long
  IdFrom As Long
  code As Long
End Type

Public Type POINTAPI
  X As Long
  Y As Long
End Type

Public Type SIZE
  cx As Long
  cy As Long
End Type

Public Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

' DWORD support
Public Type DWORD
  LoWord As Integer
  HiWord As Integer
End Type

Public Type DWORD_LONG
  N As Long
End Type

Public Type MINMAXINFO
  ptReserved As POINTAPI
  ptMaxSize As POINTAPI
  ptMaxPosition As POINTAPI
  ptMinTrackSize As POINTAPI
  ptMaxTrackSize As POINTAPI
End Type

Public Type GUID
  Data1 As Long
  Data2 As Integer
  Data3 As Integer
  Data4(0 To 7) As Byte
End Type

Public Type PictDesc
  cbSizeofStruct As Long
  picType As Long
  hImage As Long
  xExt As Long
  yExt As Long
End Type


'------------------------------------------------------------------------
' Window Style bits modifications

Public Sub CoolBar_StyleMod(hWnd As Long, NewStyle As Long, Add As Boolean, Optional OldStyle As Long)
  If OldStyle = 0 Then OldStyle = GetWindowLong(hWnd, GWL_STYLE)
  If Add Then
    Call SetWindowLong(hWnd, GWL_STYLE, (OldStyle Or NewStyle))
  Else
    Call SetWindowLong(hWnd, GWL_STYLE, (OldStyle And Not NewStyle))
  End If
End Sub


'------------------------------------------------------------------------
' Convert String

'Public Function StrFromBuffer(ByVal szStr As String) As String
'  ' Returns string before first null char encountered (if any)
'  ' from either an ANSII or Unicode string buffer.
'
'  If IsTextUnicode(ByVal StrPtr(szStr), Len(szStr), IS_TEXT_UNICODE_UNICODE_MASK) <> 0 Then szStr = StrConv(szStr, vbFromUnicode)
'  If InStr(szStr, vbNullChar) Then
'    StrFromBuffer = Left$(szStr, InStr(szStr, vbNullChar) - 1)
'  Else
'    ' If szStr had no null char, the Left$ function
'    ' above would rtn a zero length string ("").
'    StrFromBuffer = szStr
'  End If
'End Function


'------------------------------------------------------------------------
' COM/OLE Color convertor

Public Function CoolBar_CColor(Color As OLE_COLOR, Optional hPal As Long) As Long
  If OleTranslateColor(Color, hPal, CoolBar_CColor) Then CoolBar_CColor = CLR_INVALID: Debug.Assert False
End Function


'------------------------------------------------------------------------
' COM/OLE object retreival

Public Function GetObjFromPtr(ByVal ObjPtr As Long) As Object
  Dim Obj As Object
  Dim ObjGet As Object
  If ObjPtr >= OBJPTR_BASE Then
    On Error Resume Next
      Call CopyMemory(ObjGet, ObjPtr, 4) ' Turn the pointer into an ILLEGAL, UNCOUNTED interface
      Set Obj = ObjGet                   ' Assign to legal reference (Object references will be counted and registered by VB)
      Call CopyMemory(ObjGet, 0&, 4)     ' Destroy the illegal reference (Can't harm VB anymore)
    On Error GoTo 0
    Set GetObjFromPtr = Obj              ' Return legal object reference
  End If
End Function

'------------------------------------------------------------------------
' COM/OLE IPicture/Color support

Public Function GetPictureObj(ByVal hBmp As OLE_HANDLE) As IPicture
  Dim OlePic As Picture
  Dim ConversionData As PictDesc
  Dim OlePicGUID As GUID
  
  ' Fill PictDesc structure with necessary parts:
  With ConversionData
    .cbSizeofStruct = Len(ConversionData)
    .picType = vbPicTypeBitmap
    .hImage = hBmp
  End With
  
  ' Fill in IDispatch Interface ID
  With OlePicGUID
    .Data1 = &H20400
    .Data4(0) = &HC0
    .Data4(7) = &H46
  End With
  
  If OleCreatePictureIndirect(ConversionData, OlePicGUID, False, OlePic) <> 0 Then Call Err.Raise(12345, , "Failed to convert menu icon to OLE picture object!" & vbCrLf)
  Set GetPictureObj = OlePic
End Function

'------------------------------------------------------------------------
' WINAPI String Retreival

Public Function GetStrFromPtr(ByVal lpszStr As Long, ByVal ByteNum As Long) As String
  If lpszStr = 0 Then
    GetStrFromPtr = vbNullString
  Else
    Dim CharArray() As Byte
    ReDim CharArray(ByteNum) As Byte
    Call CopyMemory(CharArray(0), ByVal lpszStr, ByteNum)
    GetStrFromPtr = StrConv(CharArray, vbUnicode)
    GetStrFromPtr = Left(GetStrFromPtr, InStr(1, GetStrFromPtr, vbNullChar) - 1)
  End If
End Function
