Attribute VB_Name = "MenuBarDeclarations"
Option Explicit

'==================================================================
'
' MenuBar declarations
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================



'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?

'------------------------------------------------------------------------
' Some settings you won't use so often.

Public Const ICON_BORDER_LEFT = 1       ' Icon border: left size
Public Const ICON_BORDER_TOP = 1        ' Icon border: top size
Public Const ICON_BORDER_RIGHT = 2      ' Icon border: right size
Public Const ICON_BORDER_BOTTOM = 2     ' Icon border: bottom size


'------------------------------------------------------------------------
' Declarations for menu support

Public Declare Function GetMenuInfo Lib "user32" (ByVal hMenu As Long, lpcmi As MENUINFO) As Long
Public Declare Function GetMenuItemInfo Lib "user32" Alias "GetMenuItemInfoA" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPosition As Boolean, lpMenuItemInfo As MENUITEMINFO) As Long
Public Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Public Declare Function EndMenu Lib "user32" () As Long

Public Type MENUINFO
  cbSize As Long
  fMask As Long
  dwStyle As Long
  cyMax As Long
  hbrBack As Long
  dwContextHelpID As Long
  dwMenuData As Long
End Type

Public Enum MenuInfoMasks
  MIM_MAXHEIGHT = &H1
  MIM_BACKGROUND = &H2
  MIM_HELPID = &H4
  MIM_MENUDATA = &H8
  MIM_STYLE = &H10
  MIM_APPLYTOSUBMENUS = &H80000000
End Enum

Public Type MENUITEMINFO
  cbSize As Long
  fMask As Long
  fType As Long
  fState As Long
  wID As Long
  hSubMenu As Long
  hbmpChecked As Long
  hbmpUnchecked As Long
  dwItemData As Long
  dwTypeData As Long
  cch As Long
  hBmpItem As Long ' W98
End Type

Public Enum MenuItemInfoMasks
  MIIM_STATE = &H1
  MIIM_ID = &H2
  MIIM_SUBMENU = &H4
  MIIM_CHECKMARKS = &H8
  MIIM_TYPE = &H10
  MIIM_DATA = &H20
  MIIM_STRING = &H40
  MIIM_BITMAP = &H80
  MIIM_FTYPE = &H100
End Enum


'------------------------------------------------------------------------
' Menu bar hooking

'#define KF_EXTENDED         0x0100
'#define KF_DLGMODE          0x0800
'#define KF_MENUMODE         0x1000
'#define KF_ALTDOWN          0x2000
'#define KF_REPEAT           0x4000
'#define KF_UP               0x8000


'------------------------------------------------------------------------
' Menu bar subclassing tools

Public Function MenuBar_GetMenuItemFromID(ByVal Menus As MenuBarMenus, ByVal MenuID As Integer) As MenuItem
  Dim I As Long
  Dim J As Long
  For I = 1 To Menus.Count
    If Not Menus(I).SubMenu Is Nothing Then
      Set MenuBar_GetMenuItemFromID = MenuBar_GetSubMenuItemFromID(Menus(I).SubMenu.Menus, MenuID)
      If Not MenuBar_GetMenuItemFromID Is Nothing Then Exit Function
    End If
  Next
  Error 385 ' Command send by someone else, we return error
End Function

Private Function MenuBar_GetSubMenuItemFromID(ByVal MenuItems As MenuItems, ByVal MenuID As Integer) As MenuItem
  Dim I As Long
  Dim J As Long
  Dim MenuItem As MenuItem
  
  For I = 1 To MenuItems.Count
    Set MenuItem = MenuItems(I, mnuItemByPosition)
    If MenuItem.ID = MenuID Then
      Set MenuBar_GetSubMenuItemFromID = MenuItem
      Exit Function
    End If
    If Not MenuItem.SubMenu Is Nothing Then
      Set MenuBar_GetSubMenuItemFromID = MenuBar_GetSubMenuItemFromID(MenuItem.SubMenu.Menus, MenuID)
      If Not MenuBar_GetSubMenuItemFromID Is Nothing Then Exit Function
    End If
  Next
End Function


'------------------------------------------------------------------------
' Menu bar shortcut tools

Public Function MenuBar_GetMenuItemFromSC(ByVal Menus As MenuBarMenus, ByVal Modifier As ShiftConstants, ByVal Key As KeyCodeConstants) As MenuItem
  Dim I As Long
  Dim J As Long
  For I = 1 To Menus.Count
    If Not Menus(I).SubMenu Is Nothing Then
      Set MenuBar_GetMenuItemFromSC = MenuBar_GetSubMenuItemFromSC(Menus(I).SubMenu.Menus, Modifier, Key)
      If Not MenuBar_GetMenuItemFromSC Is Nothing Then Exit Function
    End If
  Next
End Function

Private Function MenuBar_GetSubMenuItemFromSC(ByVal MenuItems As MenuItems, ByVal Modifier As ShiftConstants, ByVal Key As KeyCodeConstants) As MenuItem
  Dim I As Long
  Dim J As Long
  Dim MenuItem As MenuItem
  
  For I = 1 To MenuItems.Count
    Set MenuItem = MenuItems(I, mnuItemByPosition)
    If MenuItem.ShortCutCode = Key Then
      If MenuItem.ShortCutModifier = Modifier Then
        Set MenuBar_GetSubMenuItemFromSC = MenuItem
        Exit Function
      End If
    End If
    If Not MenuItem.SubMenu Is Nothing Then
      Set MenuBar_GetSubMenuItemFromSC = MenuBar_GetSubMenuItemFromSC(MenuItem.SubMenu.Menus, Modifier, Key)
      If Not MenuBar_GetSubMenuItemFromSC Is Nothing Then Exit Function
    End If
  Next
End Function

Public Function MenuBar_IsParentActive(ByVal hWnd As OLE_HANDLE) As Boolean
  Dim hWndOld As OLE_HANDLE
  
  Do
    If IsWindowEnabled(hWnd) = 0 Then Exit Function
    hWndOld = hWnd
    hWnd = GetParent(hWnd)
  Loop While hWnd
  
  If IsWindowEnabled(hWndOld) = 0 Then Exit Function
  MenuBar_IsParentActive = (GetForegroundWindow() = hWndOld)
End Function

Public Function MenuBar_GetMenu(ByVal hMenu As OLE_HANDLE) As MenuContainer
  Dim MENUINFO As MENUINFO
  MENUINFO.cbSize = LenB(MENUINFO)
  MENUINFO.fMask = MIM_MENUDATA
  If GetMenuInfo(hMenu, MENUINFO) = 0 Then Err.Raise 49, , "Failed to get menu container!"
  Set MenuBar_GetMenu = GetObjFromPtr(-MENUINFO.dwMenuData)
End Function
