VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MenuBarMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Discribes an menu button in a menubar control."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Member0" ,"MenuContainer"
Option Explicit

'==================================================================
'
' Menubar Menu Class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================



'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?


'-----------------------------------------------------------
' Current Properties

Private CurButton As ToolBarButton


Public Enum MbrMenuStates
  mbrStatePressed = &H2           ' TBSTATE_PRESSED
  mbrStateEnabled = &H4           ' TBSTATE_ENABLED
  mbrStateHidden = &H8            ' TBSTATE_HIDDEN
  mbrStateWrappedAfter = &H20     ' TBSTATE_WRAP
#If (WIN32_IE >= IE3) Then
  mbrStateEllipses = &H40         ' TBSTATE_ELLIPSES
#End If 'IE3
End Enum


'===========================================================


'-----------------------------------------------------------
' Class Interface

Friend Sub MenuBarMenu_Create(ByVal hWnd As Long, ByVal Key As String, ByVal Description As String, ByVal SubMenu As PopupMenus.MenuContainer)
  Set CurButton = New ToolBarButton
  Call CurButton.ToolBarButton_Create(hWnd, Key, -ObjPtr(Me), Description, vbNullString, SubMenu)
End Sub

'-----------------------------------------------------------
' Index/Key properties

Public Property Get Key() As String
Attribute Key.VB_Description = "Returns the collection key linked to the menubar menu."
  Key = CurButton.Key
End Property

Public Property Get Index() As Long
Attribute Index.VB_Description = "Returns/Sets the index for the menu in it's collection."
  Index = CurButton.Index
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Let Index(NewValue As Long)
    CurButton.Index = NewValue
  End Property
#End If

'-----------------------------------------------------------
' Menu properties/states

Public Sub Click()
Attribute Click.VB_Description = "Fakes a click event for this menu button."
  Call CurButton.Click
End Sub

Public Property Get ID() As Integer
Attribute ID.VB_Description = "Returns the internal ID used for the menu button."
  ID = CurButton.ID
End Property

Public Property Let ID(NewValue As Integer)
  CurButton.ID = NewValue
End Property

Public Property Get SubMenu() As PopupMenus.MenuContainer
Attribute SubMenu.VB_Description = "Contains the submenu for the menu, if it has one."
  Set SubMenu = CurButton.SubMenu
End Property

Public Property Set SubMenu(ByVal NewValue As PopupMenus.MenuContainer)
  Set CurButton.SubMenu = NewValue
End Property

Public Property Get ActSeparator() As Boolean
Attribute ActSeparator.VB_Description = "Returns true if the menu is actually a separator."
  ActSeparator = (CurButton.Style And tbrStyleSeparator) = tbrStyleSeparator
End Property

Public Property Get State() As MbrMenuStates
Attribute State.VB_Description = "Returns/Sets the state the menu button is in."
  State = CurButton.State And MBSTATE_ALL  ' Filter
End Property

Public Property Let State(ByVal NewValue As MbrMenuStates)
  CurButton.State = (NewValue And MBSTATE_ALL) ' Filter
End Property

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/Sets the caption for the menu button."
  Caption = CurButton.Caption
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "If true, the button can interact with user generated events."
  Enabled = CurButton.Enabled
End Property

Public Property Let Enabled(NewValue As Boolean)
  CurButton.Enabled = NewValue
End Property

Public Property Get Visible() As Boolean
Attribute Visible.VB_Description = "If true, the button is visible to the user."
  Visible = CurButton.Visible
End Property

Public Property Let Visible(NewValue As Boolean)
  CurButton.Visible = NewValue
End Property

Public Property Get Pressed() As Boolean
Attribute Pressed.VB_Description = "Specifies whether the menu if pressed or not."
  Pressed = CurButton.Pressed
End Property

Public Property Let Pressed(NewValue As Boolean)
  CurButton.Pressed = NewValue
End Property

Public Property Get WrapMenus() As Boolean
Attribute WrapMenus.VB_Description = "If true, next menu buttons are wrapped to the next row."
  WrapMenus = CurButton.WrapButtons
End Property

Public Property Let WrapMenus(NewValue As Boolean)
  CurButton.WrapButtons = NewValue
End Property

Public Property Get Ellipses() As Boolean
Attribute Ellipses.VB_Description = "Specifies the drawing style for the menu caption it it falls of the button."
  Ellipses = CurButton.Ellipses
End Property

Public Property Let Ellipses(NewValue As Boolean)
  CurButton.Ellipses = NewValue
End Property

Public Property Get Left() As Long
Attribute Left.VB_Description = "Returns the left boundary of the menu button."
  Left = CurButton.Left
End Property

Public Property Get Top() As Long
Attribute Top.VB_Description = "Returns the top boundary of the menu button."
  Top = CurButton.Left
End Property

Public Property Get Width() As Long
Attribute Width.VB_Description = "Returns the width of the button."
  Width = CurButton.Width
End Property

Public Property Get Height() As Long
Attribute Height.VB_Description = "Returns the height of the button."
  Height = CurButton.Height
End Property

Public Property Get Available() As Boolean
Attribute Available.VB_Description = "If false, the menu is removed from the menubar, by the customize dialog box."
  Available = CurButton.Available
End Property

Friend Sub MenuBarMenu_Available(NewValue As Boolean)
  Call CurButton.ToolBarButton_Available(NewValue)
End Sub

Public Property Get Description() As String
Attribute Description.VB_Description = "Returns/Sets a description for the menu in the customize dialog box."
  Description = CurButton.Description
End Property

Public Property Let Description(NewValue As String)
  CurButton.Description = NewValue
End Property


'------------------------------------------------------------------------
' Get caption-Accelerator algorithm

Public Property Get Accelerator() As String
  Accelerator = UCase(CurButton.Accelerator)
End Property
