VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MenuBarMenus"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Contains all menu buttons added to the menubar control."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"UserDefinedCollection"
Attribute VB_Ext_KEY = "Member0" ,"MenuBarMenu"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'==================================================================
'
' MenuBar menus collection class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================



'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?


'-----------------------------------------------------------
' Current Properties

Private MB_Menus As Collection ' Storage for button-classes so we always have one counted object reference (Means: Class can't terminate)
Private CurhWnd As Long
Private MenuCaptionsNum As Long
Private MenuCaptions() As String
Private MenuCaptionsIDs() As Long
Private CurLastMenu As MenuBarMenu


'===========================================================

Friend Sub Class_InitProps(ByVal hWnd As OLE_HANDLE)
  CurhWnd = hWnd
  Set MB_Menus = New Collection
End Sub

'-----------------------------------------------------------
' Add/Remove/Count/Item

Public Function Add(Optional Index As Integer, Optional Key As String, Optional Caption As String, Optional State As MbrMenuStates = (mbrStateEnabled Or mbrStateEllipses), Optional SubMenu As PopupMenus.MenuContainer, Optional ActSeparator As Boolean, Optional Description As String) As MenuBarMenu
Attribute Add.VB_Description = "Adds a button to the menu bar control."
  Dim NewMenu(1 To 1) As TBBUTTON
  Dim NewMenuCls As MenuBarMenu
  Dim ID As Long
  
  If ActSeparator Then
    If Caption <> "" Then Error 5
    If Description <> "" Then Error 5
    If Not SubMenu Is Nothing Then Error 5
  ElseIf Not SubMenu Is Nothing Then
    If Not TypeOf SubMenu Is MenuContainer Then Error 5
    If IsMenu(SubMenu.hMenu) = 0 Then Error 5
  End If
  
  If Len(Key) Then
    On Error Resume Next
      Set NewMenuCls = Me.Item(Key)
    On Error GoTo 0
    If Not NewMenuCls Is Nothing Then Error 457
  End If
  
  ' Add menu by api
  Set NewMenuCls = New MenuBarMenu
  With NewMenu(1)
    .iBitmap = tbrButtonBitmapNone
    .fsState = State
    .fsStyle = (tbrStyleAutoSize Or IIf(ActSeparator, tbrStyleSeparator, tbrStyleButton)) ' And Not tbrStyleDropDown
    .dwData = -ObjPtr(NewMenuCls)
    If Not ActSeparator Then .idCommand = ToolBar_GetUniqueID(CurhWnd) ' for WM_COMMAND
    If Len(Caption) > 0 Then
      .iString = MenuBarMenu_AddString(Caption)
    Else
      .iString = -1 ' Properly the most invalid value you can pass through.
    End If
  End With
  If SendMessage(CurhWnd, TB_ADDBUTTONS, UBound(NewMenu), NewMenu(LBound(NewMenu))) = 0 Then Error 5
  
  ' Add button by vb
  Call NewMenuCls.MenuBarMenu_Create(CurhWnd, Key, Description, SubMenu)
  Call MB_Menus.Add(NewMenuCls, "MenuCls=" & -NewMenu(1).dwData)
  
  ' Resize menubar
  Call ToolBar_Resize(CurhWnd)
'  Dim AreaBtn As RECT
'  Dim AreaTbr As RECT
'  Call SendMessage(CurhWnd, TB_GETITEMRECT, SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, Byval 0) - 1, AreaBtn)
'  Call GetWindowRect(CurhWnd, AreaTbr)
'  Call MoveWindow(CurhWnd, AreaTbr.Left, AreaTbr.Top, AreaBtn.Right - AreaBtn.Left, AreaBtn.Bottom - AreaBtn.Top, 1)
  Set Add = NewMenuCls
End Function

Public Property Get Count() As Long
Attribute Count.VB_Description = "Returns the number of buttons in the menubar control."
  Count = SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0)
End Property

Public Sub Remove(Index As Variant)
Attribute Remove.VB_Description = "Removes a menu button."
  Dim Menu As MenuBarMenu
  Set Menu = Me.Item(Index)
  If SendMessage(CurhWnd, TB_DELETEBUTTON, Menu.Index - 1, ByVal 0&) = 0 Then Error 5
  Call MB_Menus.Remove("MenuCls=" & -ObjPtr(Menu))
  Set Menu = Nothing
End Sub

Public Property Get Item(Index As Variant) As MenuBarMenu
Attribute Item.VB_Description = "Returns a MenuBarMenu object, which represents a single button in the menubar."
Attribute Item.VB_UserMemId = 0
Attribute Item.VB_MemberFlags = "200"
  Dim Items As Long
  Items = SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0)
  
  If CStr(Val(Index)) = CStr(Index) Then ' Number?
    If Index > Items Or Index < 1 Then Error 5
    Set Item = ToolBar_GetItem(CurhWnd, Index - 1)
    Exit Property
  Else
    Dim I As Long
    Dim Ptr As Long
    Dim Menu As MenuBarMenu
    
    If Not CurLastMenu Is Nothing Then
      If CurLastMenu.Key = Index Then
        Set Item = CurLastMenu
        Exit Property
      End If
    End If
    
    For I = 0 To Items - 1
      Set Menu = ToolBar_GetItem(CurhWnd, I)
      If Not Menu Is Nothing Then
        If Menu.Key = Index Then
          Set CurLastMenu = Menu
          Set Item = Menu
          Exit Property
        End If
      Else
        Debug.Print "MenuBar: Invalid menu reference encountered (Menu " & I + 1 & ")"
      End If
    Next
  End If
  
  Set CurLastMenu = Nothing
  Error 5
End Property


'===========================================================


'-----------------------------------------------------------
' Utils

Friend Function MenuBarMenu_AddString(ByVal Caption As String) As Long
  Dim ID As Long
  Dim I As Long
  Dim CharArray() As Byte
  Dim sAccel As String
  
  ' Check if we already have the string - if we do, then use that
  ID = -1
  For I = 1 To MenuCaptionsNum
    If (MenuCaptions(I) = Caption) Then
      ID = MenuCaptionsIDs(I)
      Exit For
    End If
  Next I
  
  If (ID = -1) Then
    ' Add the string, it was not loaded jet to the toolbar string pool
    CharArray = StrConv(Caption, vbFromUnicode)
    I = UBound(CharArray) + 2
    ReDim Preserve CharArray(0 To I) As Byte
    CharArray(I - 1) = 0
    CharArray(I) = 0
    ID = SendMessage(CurhWnd, TB_ADDSTRING, 0, CharArray(0))
    
    ' Save the button to a locale string pool, we can't read the toolbar string pool!?
    MenuCaptionsNum = MenuCaptionsNum + 1
    ReDim Preserve MenuCaptions(1 To MenuCaptionsNum) As String
    ReDim Preserve MenuCaptionsIDs(1 To MenuCaptionsNum) As Long
    MenuCaptions(MenuCaptionsNum) = Caption
    MenuCaptionsIDs(MenuCaptionsNum) = ID
  End If
  
  MenuBarMenu_AddString = ID
End Function


