VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ReBarBand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Embeds a single band from the rebar control."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Option Explicit

'==================================================================
'
' ReBar Band Class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================


'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?


'-----------------------------------------------------------
' Current Properties

Private CurhWnd As Long
'Private CurTooltip As String
Private CurBackground As IPicture
Private CollectionKey As String
Private CurLastIndex As Long

Public Enum RbrBandBorderIndex
  rbrBorderLeft = 0
  rbrBorderTop = 1
  rbrBorderRight = 2
  rbrBorderBottom = 3
End Enum

Public Enum RbrGripperStyle
  rbrShowWhenDragable = 0
  rbrShowAlways = 1
  rbrShowNever = 2
End Enum

Public Enum RbrBandStyles
  rbrBreakNewLine = &H1          ' RBBS_BREAK          break to new line
  rbrFixedSize = &H2             ' RBBS_FIXEDSIZE      band can't be sized
  rbrDisplayChildEdge = &H4      ' RBBS_CHILDEDGE      edge around top & bottom of child window
  rbrHidden = &H8                ' RBBS_HIDDEN         don't show
  rbrHideWhenVertical = &H10     ' RBBS_NOVERT         don't show when vertical
  rbrBackgroundFixed = &H20      ' RBBS_FIXEDBMP       bitmap doesn't move during band resize
#If (WIN32_IE >= IE4) Then
  rbrVariableHeight = &H40       ' RBBS_VARIABLEHEIGHT The band can be resized by the rebar control; cyIntegral and cyMaxChild affect how
  rbrGripperAlways = &H80        ' RBBS_GRIPPERALWAYS  always show the gripper
  rbrGripperNever = &H100        ' RBBS_NOGRIPPER      never a gripper
#End If
#If (WIN32_IE >= IE5) Then
  rbrDisplayChevron = &H200      ' RBBS_USECHEVRON     IE5: Show drop down button when band-width < cxIdeal
#End If
#If (WIN32_IE >= IE501) Then
  rbrHideBandTitle = &H400       ' RBBS_HIDETITLE      IE5.1: keep band title hidden
#End If
End Enum


'===========================================================


'-----------------------------------------------------------
' Class Interface

Private Sub Class_Initialize()
  CollectionKey = "0"
End Sub

Friend Sub ReBarBand_Create(hWnd As Long, Optional Key As String, Optional Background As IPicture)
  If CollectionKey <> "0" Then Error 383
  CurhWnd = hWnd
  CollectionKey = Key
  Set CurBackground = Background ' Store a object reference for the internal object instance counter; otherwise the bitmap will be destroyed!
End Sub


'-----------------------------------------------------------
' Key/Index/hWnd/Toolbar

Public Property Get Key() As String
Attribute Key.VB_Description = "Returns a string value that identifies the object."
  Key = CollectionKey
End Property

Public Property Get Index() As Long
Attribute Index.VB_Description = "Returns/Sets the current index of the band in it's band collection."
  Dim I As Long
  Dim Ptr As Long
  Dim Band As REBARBANDINFO
  
  Band.cbSize = LenB(Band)
  Band.fMask = RBBIM_ID
  Ptr = -ObjPtr(Me)
  
  If CurLastIndex Then
    If SendMessage(CurhWnd, RB_GETBANDINFO, CurLastIndex - 1, Band) <> 0 Then
      If Band.wID = Ptr Then
        Index = CurLastIndex
        Exit Property
      End If
    End If
  End If
  
  For I = 0 To SendMessage(CurhWnd, RB_GETBANDCOUNT, 0, ByVal 0) - 1
    If SendMessage(CurhWnd, RB_GETBANDINFO, I, Band) <> 0 Then
      If Band.wID = Ptr Then
        Index = I + 1
        CurLastIndex = Index
        Exit Property
      End If
    Else
      Debug.Print "ReBar: Band Access Error (Band " & I & ")"
    End If
  Next
  
  CurLastIndex = 0
  Err.Raise 31004, "ReBar.Bands", "No Object"
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Let Index(NewValue As Long)
    If SendMessage(CurhWnd, RB_MOVEBAND, Me.Index - 1, ByVal NewValue - 1) = 0 Then Error 380
    Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOSIZE)
    Call SendMessage(CurhWnd, WM_SIZE, 0, ByVal 0) ' Not really cool, but do you know something better?
  End Property
#End If

Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle to the current child window allocated inside the band."
Attribute hWnd.VB_UserMemId = -515
  hWnd = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILD).hWndChild
End Property

'-----------------------------------------------------------
' Settings

Public Property Get RowHeight() As Long
Attribute RowHeight.VB_Description = "Returns the height of the row where the band in placed in."
  RowHeight = SendMessage(CurhWnd, RB_GETROWHEIGHT, Me.Index - 1, ByVal 0)
End Property

Public Property Get ChildWidth() As Long
Attribute ChildWidth.VB_Description = "Returns the width of the child window it carries."
  ChildWidth = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE).cx
End Property

Property Let ChildWidth(NewValue As Long)
  Dim Band As REBARBANDINFO
  Dim Index As Long
  Index = Me.Index - 1
  Band = ReBarBand_Info(CurhWnd, Index, RBBIM_CHILDSIZE)
  Band.cx = NewValue
  ReBarBand_Info(CurhWnd, Index, RBBIM_CHILDSIZE) = Band
End Property


Public Property Get Background() As IPictureDisp
Attribute Background.VB_Description = "Sets the background bitmap used for this band."
  Dim Handle As Long
  Handle = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_BACKGROUND).hbmBack
  If CurBackground Is Nothing Then Set CurBackground = GetPictureObj(0)
  If Handle = CurBackground.Handle Then
    Set Background = CurBackground
  Else
    Set Background = GetPictureObj(Handle)
  End If
End Property

Public Property Let Background(NewValue As IPictureDisp)
  Set Me.Background = NewValue
End Property

Public Property Set Background(NewValue As IPictureDisp)
  If NewValue Is Nothing Then Error 380
  If Not (TypeOf NewValue Is StdPicture Or TypeOf NewValue Is IPicture Or TypeOf NewValue Is IPictureDisp) Then Error 380
  Dim Band As REBARBANDINFO
  Band.hbmBack = NewValue.Handle
  ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_BACKGROUND) = Band
  Set CurBackground = NewValue
  Call LockWindowUpdate(CurhWnd)
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOSIZE Or SWP_HIDEWINDOW)
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOSIZE Or SWP_SHOWWINDOW)
  Call LockWindowUpdate(0)
End Property

#If (WIN32_IE >= IE4) Then
  Property Get IdealWidth() As Long
Attribute IdealWidth.VB_Description = "Returns/Sets the ideal width used for this band. If the band is smaller, a gripper will be shown."
    IdealWidth = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_IDEALSIZE).cxIdeal
  End Property
  
  Property Let IdealWidth(NewValue As Long)
    Dim Band As REBARBANDINFO
    Band.cxIdeal = NewValue
    ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_IDEALSIZE) = Band
  End Property
  
  Property Get HeaderWidth() As Long
Attribute HeaderWidth.VB_Description = "Returns/Sets the width of the band's header. (Gripper+Caption)."
    HeaderWidth = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_HEADERSIZE).cxHeader
  End Property
  
  Property Let HeaderWidth(NewValue As Long)
    Dim Band As REBARBANDINFO
    Band.cxHeader = NewValue
    ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_HEADERSIZE) = Band
  End Property
  
  Public Property Get ChildVarHeight() As Long
Attribute ChildVarHeight.VB_Description = "Returns the variable height of the band, if it's a variable-height-band."
    ChildVarHeight = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE).cyChild
  End Property
  
  Property Let ChildVarHeight(NewValue As Long)
    Dim Band As REBARBANDINFO
    Band = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE)
    Band.cyChild = NewValue
    ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE) = Band
  End Property
  
  Public Property Get ChildMaxVarHeight() As Long
Attribute ChildMaxVarHeight.VB_Description = "Returns the maximum height of the band, if it's a variable-height-band."
    ChildMaxVarHeight = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE).cyMaxChild
  End Property
  
  Property Let ChildMaxVarHeight(NewValue As Long)
    Dim Band As REBARBANDINFO
    Band = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE)
    Band.cyMaxChild = NewValue
    ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE) = Band
  End Property
  
  Public Property Get ChildVarHeightGrow() As Long
Attribute ChildVarHeightGrow.VB_Description = "Returns the growing amout of the band, if it's a variable-height-band."
    ChildVarHeightGrow = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE).cyIntegral
  End Property
  
  Property Let ChildVarHeightGrow(NewValue As Long)
    Dim Band As REBARBANDINFO
    Band = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE)
    Band.cyIntegral = NewValue
    ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE) = Band
  End Property
  
  Public Property Get VariableHeight() As Boolean
Attribute VariableHeight.VB_Description = "If True, the band can have difference heights."
    VariableHeight = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_STYLE).fStyle And rbrVariableHeight
  End Property
  
  Property Let VariableHeight(NewValue As Boolean)
    Call ReBarBand_StyleMod(CurhWnd, Me.Index - 1, rbrVariableHeight, NewValue)
  End Property
  
  Public Property Get GripperStyle() As RbrGripperStyle
Attribute GripperStyle.VB_Description = "Specifies the behavour of the gripper located at the left edge."
    Dim Style As RbrBandStyles
    Style = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_STYLE).fStyle
    If Style And rbrGripperAlways Then
      GripperStyle = rbrShowAlways
    ElseIf Style And rbrGripperNever Then
      GripperStyle = rbrShowNever
    Else
      GripperStyle = rbrShowWhenDragable
    End If
  End Property
  
  Public Property Let GripperStyle(NewValue As RbrGripperStyle)
    If NewValue < rbrShowWhenDragable And NewValue > rbrShowAlways Then Error 380
    Dim Index As Long
    Index = Me.Index - 1
    Call ReBarBand_StyleMod(CurhWnd, Index, rbrGripperAlways, (NewValue = rbrShowAlways))
    Call ReBarBand_StyleMod(CurhWnd, Index, rbrGripperNever, (NewValue = rbrShowNever))
  End Property
#End If

Public Property Get FixedBackground() As Boolean
Attribute FixedBackground.VB_Description = "If true, the band's background doesn't move at all."
  FixedBackground = (ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_STYLE).fStyle And rbrBackgroundFixed)
End Property

Public Property Let FixedBackground(NewValue As Boolean)
  Call ReBarBand_StyleMod(CurhWnd, Me.Index - 1, rbrBackgroundFixed, NewValue)
End Property

Public Property Get DisplayChildEdge() As Boolean
Attribute DisplayChildEdge.VB_Description = "If true, an extra edge is added between the border and the child of the band."
  DisplayChildEdge = (ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_STYLE).fStyle And rbrDisplayChildEdge)
End Property

Public Property Let DisplayChildEdge(NewValue As Boolean)
  Call ReBarBand_StyleMod(CurhWnd, Me.Index - 1, rbrDisplayChildEdge, NewValue)
End Property

#If (WIN32_IE >= IE5) Then
  Public Property Get DisplayChevron() As Boolean
Attribute DisplayChevron.VB_Description = "Specifies whether a chevron is displayed at the end of the band."
    DisplayChevron = (ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_STYLE).fStyle And rbrDisplayChevron)
  End Property
  
  Public Property Let DisplayChevron(NewValue As Boolean)
    Call ReBarBand_StyleMod(CurhWnd, Me.Index - 1, rbrDisplayChevron, NewValue)
  End Property
#End If

#If (WIN32_IE >= IE501) Then
  Public Property Get DisplayCaption() As Boolean
    DisplayCaption = Not (ReBarBand_Info(RBBIM_STYLE).fStyle And rbrHideBandTitle)
  End Property
  
  Public Property Let DisplayCaption(NewValue As Boolean)
    Call ReBarBand_StyleMod(rbrHideBandTitle, Not NewValue)
  End Property
#End If

Public Property Get FixedSize() As Boolean
Attribute FixedSize.VB_Description = "If true, the band won't resize."
  FixedSize = (ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_STYLE).fStyle And rbrFixedSize)
End Property

Public Property Let FixedSize(NewValue As Boolean)
  Call ReBarBand_StyleMod(CurhWnd, Me.Index - 1, rbrFixedSize, NewValue)
End Property

Public Property Get Visible() As Boolean
Attribute Visible.VB_Description = "True is the band is visible."
  Visible = Not CBool(ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_STYLE).fStyle And rbrHidden)
End Property

Public Property Let Visible(NewValue As Boolean)
  Call ReBarBand_StyleMod(CurhWnd, Me.Index - 1, rbrHidden, Not NewValue)
  Call SetWindowPos(Me.hWnd, 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOSIZE Or IIf(NewValue, SWP_SHOWWINDOW, SWP_HIDEWINDOW))
End Property

Public Property Get VerticalVisible() As Boolean
Attribute VerticalVisible.VB_Description = "If False, the band won't be visible when the rebar is orientated vertically."
  VerticalVisible = Not CBool(ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_STYLE).fStyle And rbrHideWhenVertical)
End Property

Public Property Let VerticalVisible(NewValue As Boolean)
  Call ReBarBand_StyleMod(CurhWnd, Me.Index - 1, rbrHideWhenVertical, Not NewValue)
End Property

Property Get MinWidth() As Long
Attribute MinWidth.VB_Description = "Specifies the minimum width of the band."
  MinHeight = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE).cxMinChild
End Property

Property Let MinWidth(NewValue As Long)
  Dim Band As REBARBANDINFO
  Dim Index As Long
  Index = Me.Index - 1
  Band = ReBarBand_Info(CurhWnd, Index, RBBIM_CHILDSIZE)
  Band.cxMinChild = NewValue
  ReBarBand_Info(CurhWnd, Index, RBBIM_CHILDSIZE) = Band
End Property

Property Get MinHeight() As Long
Attribute MinHeight.VB_Description = "Specifies the minimum height of the band."
  MinHeight = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_CHILDSIZE).cyMinChild
End Property

Property Let MinHeight(NewValue As Long)
  Dim Band As REBARBANDINFO
  Dim Index As Long
  Index = Me.Index - 1
  Band = ReBarBand_Info(CurhWnd, Index, RBBIM_CHILDSIZE)
  Band.cyMinChild = NewValue
  ReBarBand_Info(CurhWnd, Index, RBBIM_CHILDSIZE) = Band
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Overrides the default rebar band text color."
  ForeColor = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_COLORS).clrFore
End Property

Public Property Let ForeColor(NewValue As OLE_COLOR)
  Dim Band As REBARBANDINFO
  Dim Index As Long
  Index = Me.Index - 1
  Band = ReBarBand_Info(CurhWnd, Index, RBBIM_COLORS)
  Band.clrFore = NewValue
  ReBarBand_Info(CurhWnd, Index, RBBIM_COLORS) = Band
  Call LockWindowUpdate(CurhWnd)
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_HIDEWINDOW))
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_SHOWWINDOW))
  Call LockWindowUpdate(0)
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Overrides the default background color of the rebar."
  BackColor = ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_COLORS).clrBack
End Property

Public Property Let BackColor(NewValue As OLE_COLOR)
  Dim Band As REBARBANDINFO
  Dim Index As Long
  Index = Me.Index - 1
  Band = ReBarBand_Info(CurhWnd, Index, RBBIM_COLORS)
  Band.clrBack = NewValue
  ReBarBand_Info(CurhWnd, Index, RBBIM_COLORS) = Band
  Call LockWindowUpdate(CurhWnd)
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_HIDEWINDOW))
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_SHOWWINDOW))
  Call LockWindowUpdate(0)
End Property

'Public Property Get Caption() As String
'  Dim Band As REBARBANDINFO
'  Dim BandCaption() As Byte
'  Dim BandInfo As REBARBANDINFO
'  BandInfo.cbSize = LenB(BandInfo)
'  BandInfo.fMask = RBBIM_TEXT
'  BandCaption = Space(255) & Chr(0) 'StrConv(Space(255) & Chr(0), vbFromUnicode) ' To C++ Byte Array String (Each char is a ascii code in the array (array item size = 1 byte))
'  Band.lpText = VarPtr(BandCaption(0))
'  Band.cch = 256
'  If SendMessage(CurhWnd, RB_GETBANDINFO, Me.Index - 1, BandInfo) = 0 Then Error 383
'  Caption = ReBarBand_StrFromBuffer(StrConv(BandCaption, vbUnicode))
'End Property

Public Property Let Caption(NewValue As String)
Attribute Caption.VB_Description = "Returns the caption of the band, if it has one."
  Dim Band As REBARBANDINFO
  Dim BandCaption() As Byte
  BandCaption = StrConv(NewValue & Chr(0), vbFromUnicode) ' To C++ Byte Array String (Each char is a ascii code in the array (array item size = 1 byte))
  Band.lpText = VarPtr(BandCaption(0))
  Band.cch = Len(NewValue)
  ReBarBand_Info(CurhWnd, Me.Index - 1, RBBIM_TEXT) = Band
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get Left() As Long
Attribute Left.VB_Description = "Returns the left position of the band."
    Left = ReBarBand_Rect(CurhWnd, Me.Index - 1).Left
  End Property
  
  Public Property Get Top() As Long
Attribute Top.VB_Description = "Returns the top postion of the band."
    Top = ReBarBand_Rect(CurhWnd, Me.Index - 1).Top
  End Property
  
  Public Property Get Width() As Long
Attribute Width.VB_Description = "Specifies the width of the band."
    Dim RECT As RECT
    RECT = ReBarBand_Rect(CurhWnd, Me.Index - 1)
    Width = RECT.Right - RECT.Left
  End Property
  
  Public Property Get Height() As Long
Attribute Height.VB_Description = "Returns the height of the band."
    Dim RECT As RECT
    RECT = ReBarBand_Rect(CurhWnd, Me.Index - 1)
    Height = RECT.Bottom - RECT.Top
  End Property
  
  Public Sub Maximize(Optional UseIdealWidth As Boolean)
Attribute Maximize.VB_Description = "Maximizes the band"
    Call SendMessage(CurhWnd, RB_MAXIMIZEBAND, Me.Index - 1, CLng(CByte(UseIdealWidth)))
  End Sub
  
  Public Sub Minimize()
Attribute Minimize.VB_Description = "Minimizes the band."
    Call SendMessage(CurhWnd, RB_MINIMIZEBAND, Me.Index - 1, ByVal 0)
  End Sub
  
  Public Property Get BorderWidth(Optional BorderIndex As RbrBandBorderIndex) As Long
Attribute BorderWidth.VB_Description = "Returns the width of certain borders in the band."
    Dim Borders As RECT
    Call SendMessage(CurhWnd, RB_GETBANDBORDERS, Me.Index - 1, Borders)
    Select Case BorderIndex
      Case rbrBorderLeft:   BorderWidth = Borders.Left
      Case rbrBorderTop:    BorderWidth = Borders.Top
      Case rbrBorderRight:  BorderWidth = Borders.Right
      Case rbrBorderBottom: BorderWidth = Borders.Bottom
      Case Else:            Error 5
    End Select
  End Property
#End If

#If (WIN32_IE >= IE5) Then
  Public Sub PushChevron()
Attribute PushChevron.VB_Description = "Generates an ChevronPushed event."
    Call SendMessage(CurhWnd, RB_PUSHCHEVRON, Me.Index - 1, ByVal CLng(True)) ' Use lAppvalue internal: wo send it?!
  End Sub
#End If
