VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ReBarBands"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Contains all the bands loaded in the rebar control."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"UserDefinedCollection"
Attribute VB_Ext_KEY = "Member0" ,"ReBarBand"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'==================================================================
'
' ReBar Band Collection Class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================



'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?


'-----------------------------------------------------------
' Current Properties

Private RB_Bands As Collection
Private CurhWnd As Long
Private CurhWndNotify As Long
Private CurReBarObj As Long
Private CurLastBand As ReBarBand



'===========================================================


Friend Sub ReBarBand_Create(hWndReBar As Long, hWndNotify As Long, ReBarObjPtr As Long)
  CurhWnd = hWndReBar
  CurhWndNotify = hWndNotify
  CurReBarObj = ReBarObjPtr
  Set RB_Bands = New Collection
End Sub


'-----------------------------------------------------------
' Add/Remove/Count/Item

#If (WIN32_IE >= IE5) Then
  Public Function Add(Optional Index As Long, Optional Key As String, Optional Caption As String, Optional StyleFlags As RbrBandStyles = (rbrBackgroundFixed Or rbrDisplayChildEdge Or rbrBreakNewLine Or rbrGripperAlways), Optional Background As IPicture, Optional hWndChild As Long, Optional Width As Long, Optional MinWidth As Long, Optional MinHeight As Long, Optional HeaderImageIndex As Long = -1, Optional ByVal IdealWidth As Long = -1, Optional VarHeightInit As Long, Optional VarHeightMax As Long, Optional VarHeightGrow As Long) As ReBarBand
Attribute Add.VB_Description = "Adds a band to the rebar control. When you don't specify a child window handle, a toolbar band will be created."
#ElseIf (WIN32_IE >= IE4) Then
  Public Function Add(Optional Index As Long, Optional Key As String, Optional Caption As String, Optional StyleFlags As RbrBandStyles = (rbrBackgroundFixed Or rbrDisplayChildEdge Or rbrBreakNewLine Or rbrGripperAlways), Optional Background As IPicture, Optional hWndChild As Long, Optional Width As Long, Optional MinWidth As Long, Optional MinHeight As Long, Optional HeaderImageIndex As Long = -1, Optional ByVal IdealWidth As Long = -1, Optional VarHeightInit As Long, Optional VarHeightMax As Long, Optional VarHeightGrow As Long) As ReBarBand
#Else
  Public Function Add(Optional Index As Long, Optional Key As String, Optional Caption As String, Optional StyleFlags As RbrBandStyles = (rbrBackgroundFixed Or rbrDisplayChildEdge Or rbrBreakNewLine), Optional Background As IPicture, Optional hWndChild As Long, Optional Width As Long, Optional MinWidth As Long, Optional MinHeight As Long, Optional HeaderImageIndex As Long = -1) As ReBarBand
#End If
  Dim NewBand As ReBarBand
  Dim BandCaption() As Byte
  Dim BandInfo As REBARBANDINFO
  Dim Visible As Boolean
  Dim ClassName As String
  
  ' We could make the band flat if it's a toolbar (Classname == ToolbarWindow32 || ToolbarWndClass contains ToolbarWindow32)
  If Len(Key) Then
    On Error Resume Next
      Set NewBand = Me.Item(Key)
    On Error GoTo 0
    If Not NewBand Is Nothing Then Error 457
  End If
  
  If Not Background Is Nothing Then
    If Not (TypeOf Background Is StdPicture Or TypeOf Background Is IPicture Or TypeOf Background Is IPictureDisp) Then Error 5
  End If
  
#If (WIN32_IE >= IE4) Then
  If (StyleFlags And rbrVariableHeight) Then
    If (VarHeightInit = 0 And VarHeightMax = 0 And VarHeightGrow = 0) Then Error 5
  ElseIf (VarHeightInit <> 0 Or VarHeightMax <> 0 Or VarHeightGrow <> 0) Then
    Error 5
  End If
#End If
  
  Set NewBand = New ReBarBand
  With BandInfo
    .cbSize = Len(BandInfo)
    .fMask = RBBIM_STYLE Or RBBIM_ID Or RBBIM_SIZE Or RBBIM_COLORS    ' Overrides defualt color.
    .fStyle = StyleFlags
    .wID = -ObjPtr(NewBand)
    .clrBack = rbrColorNone
    .clrFore = rbrColorNone
    .cx = Width
    .fMask = .fMask
#If (WIN32_IE >= IE4) Then
    If IdealWidth <> 0 Then .fMask = .fMask Or RBBIM_IDEALSIZE
#End If
    If HeaderImageIndex > -1 Then
     .iImage = HeaderImageIndex
     .fMask = .fMask Or RBBIM_IMAGE
    End If
    If Caption <> "" Then
      BandCaption = StrConv(Caption & Chr(0), vbFromUnicode) ' To C++ Byte Array String (Each char is a ascii code in the array (array item size = 1 byte))
      .lpText = VarPtr(BandCaption(0))
      .cch = Len(Caption)
      .fMask = .fMask Or RBBIM_TEXT
    End If
    If Not Background Is Nothing Then
      .hbmBack = Background.Handle
      .fMask = .fMask Or RBBIM_BACKGROUND
    End If
    If hWndChild <> 0 Then
      If IsWindow(hWndChild) = 0 Then Error 5
      .hWndChild = hWndChild
      .fMask = .fMask Or RBBIM_CHILD
      ClassName = Space(128)
      ClassName = Trim(Left(ClassName, GetClassName(.hWndChild, ClassName, Len(ClassName))))
    End If
#If (WIN32_IE >= IE4) Then
    If MinWidth > 0 Or MinHeight > 0 Or ((VarHeightInit > 0 Or VarHeightMax > 0 Or VarHeightGrow > 0) And StyleFlags And rbrVariableHeight) Then
'     If IdealWidth = -1 And hWndChild = -1 Then IdealWidth = MinWidth
      .fMask = .fMask Or RBBIM_CHILDSIZE
      .cxMinChild = MinWidth
      .cyMinChild = MinHeight
'     If StyleFlags And rbrVariableHeight Then
      .cyChild = VarHeightInit
      .cyMaxChild = VarHeightMax
      .cyIntegral = VarHeightGrow
'     End If
    ElseIf .hWndChild <> 0 Then
#Else
    If .hWndChild <> 0 Then
#End If
      Dim Area As RECT
      Dim MINMAX As MINMAXINFO
      Call GetWindowRect(.hWndChild, Area)
      
      ' Set defaults
      .fMask = .fMask Or RBBIM_CHILDSIZE
      'If InStr(1, ClassName, "toolbar", vbTextCompare) = 0 Then
      .cxMinChild = 64
      'End If
      .cyMinChild = Area.Bottom - Area.Top
      MINMAX.ptMinTrackSize.X = .cxMinChild
      MINMAX.ptMinTrackSize.Y = .cyMinChild
      
      ' The window may change the defaults internally.
      ' The message wParam contains a hWnd (wParam not used normally)
      ' You can use it, and discover that this isn't a normal MINMAX request.
      If SendMessage(.hWndChild, WM_GETMINMAXINFO, CurhWnd, MINMAX) = 0 Then
        .cxMinChild = MINMAX.ptMinTrackSize.X
        .cyMinChild = MINMAX.ptMinTrackSize.Y
#If (WIN32_IE >= IE4) Then
        If MINMAX.ptMaxTrackSize.Y Then
          IdealWidth = MINMAX.ptMaxTrackSize.Y
        ElseIf MINMAX.ptMaxSize.Y Then
          IdealWidth = MINMAX.ptMaxSize.Y
        End If
#End If
      ' Else : Message not processed, we can use our own values
      End If
#If (WIN32_IE >= IE4) Then
      If IdealWidth = -1 Then IdealWidth = Area.Right - Area.Left
#End If
    End If
#If (WIN32_IE >= IE4) Then
    .cxIdeal = IdealWidth
#End If
    Call SetProp(.hWndChild, RBR_PROP_PARENT, GetParent(.hWndChild))
    
    Dim NMSECRET As NMRB_SECRET
    NMSECRET.hdr.code = RbrSecretNotifications.RBN_CHILD_ATTACH
    NMSECRET.hdr.hWndFrom = CurhWnd
    NMSECRET.hdr.IdFrom = .wID
    NMSECRET.hWndBandChild = .hWndChild
    Call SendMessage(.hWndChild, WM_NOTIFY, 0, NMSECRET)
    Visible = Not ((.fStyle And rbrHidden) = rbrHidden)
    Call SetWindowLong(CurhWnd, GWL_STYLE, GetWindowLong(CurhWnd, GWL_STYLE) Or WS_CHILD)
    Call NewBand.ReBarBand_Create(CurhWnd, Key, Background)
    Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_FRAMECHANGED Or SWP_SHOWWINDOW))
    If SendMessage(CurhWnd, RB_INSERTBANDA, (Index - 1), BandInfo) = 0 Then Error 5
  End With
  If Not Visible Then
    DoEvents
    NewBand.Visible = False
  End If
  Call RB_Bands.Add(NewBand, "BandCls=" & ObjPtr(NewBand))
  Set Add = NewBand
End Function

Public Sub Remove(Index As Variant)
Attribute Remove.VB_Description = "Removes a band from the rebar. If you  used a custom child window, it will be positioned invisible at his original parent window."
  Dim Band As ReBarBand
  Dim BandhWnd As OLE_HANDLE
  Dim BandPtr As OLE_HANDLE
  
  Set Band = Me.Item(Index)
  BandhWnd = Band.hWnd
  BandPtr = ObjPtr(Band)
  
  If SendMessage(CurhWnd, RB_DELETEBAND, Band.Index - 1, ByVal 0&) = 0 Then Error 5
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_FRAMECHANGED))
  Set Band = Nothing
  Call RB_Bands.Remove("BandCls=" & BandPtr)
End Sub

Public Property Get Count() As Long
Attribute Count.VB_Description = "Returns the number of bands."
  Count = SendMessage(CurhWnd, RB_GETBANDCOUNT, 0, ByVal 0)
End Property

Public Property Get Item(Index As Variant) As ReBarBand
Attribute Item.VB_Description = "Returns the specified rebar band."
Attribute Item.VB_UserMemId = 0
Attribute Item.VB_MemberFlags = "200"
  Dim Items As Long
  Items = SendMessage(CurhWnd, RB_GETBANDCOUNT, 0, ByVal 0)
  
  If CStr(Val(Index)) = CStr(Index) Then ' Number?
    If Index > Items Or Index < 1 Then Error 5
    Set Item = ReBar_GetItem(CurhWnd, Index - 1)
    Exit Property
  Else
    Dim I As Long
    Dim Ptr As Long
    Dim Band As ReBarBand
    
    If Not CurLastBand Is Nothing Then
      If CurLastBand.Key = Index Then
        Set Item = CurLastBand
        Exit Property
      End If
    End If
    
    For I = 0 To Items - 1
      Set Band = ReBar_GetItem(CurhWnd, I)
      If Not Band Is Nothing Then
        If Band.Key = Index Then
          Set CurLastBand = Band
          Set Item = Band
          Exit Property
        End If
      Else
        Debug.Print "ReBar: Invalid Band reference encountered (Band " & I + 1 & ")"
      End If
    Next
  End If
  
  Set CurLastBand = Nothing
  Error 5
End Property

