Attribute VB_Name = "ReBarDeclarations"
Option Explicit

'==================================================================
'
' ReBar Declarations
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================



'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?

'------------------------------------------------------------------------
' Declarations

Public Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Public Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Public Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hWnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Public Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Public Declare Function IntersectRect Lib "user32" (lpDestRect As RECT, lpSrc1Rect As RECT, lpSrc2Rect As RECT) As Long
Public Declare Function EqualRect Lib "user32" (lpRect1 As RECT, lpRect2 As RECT) As Long

#If (WIN32_IE >= IE3) Then
  Public Const REBARCLASSNAME = "ReBarWindow32"
  
  Public Const RBR_PROP_MSG As String = "RBR_SecretMsgsTo"
  Public Const RBR_PROP_PARENT As String = "RBR_hWndPPrev"
  Public Const RBR_PROP_BANDHWND As String = "RBR_hWndBand"
  
  Public Enum ReBarMessages
    RB_INSERTBANDA = (WM_USER + 1)
    RB_DELETEBAND = (WM_USER + 2)
    RB_GETBARINFO = (WM_USER + 3)
    RB_SETBARINFO = (WM_USER + 4)
#If (WIN32_IE < IE4) Then
    RB_GETBANDINFO = (WM_USER + 5)
#End If
    RB_SETBANDINFOA = (WM_USER + 6)
    RB_SETPARENT = (WM_USER + 7)
#If (WIN32_IE >= IE4) Then
    RB_HITTEST = (WM_USER + 8)
    RB_GETRECT = (WM_USER + 9)
#End If
    RB_INSERTBANDW = (WM_USER + 10)
    RB_SETBANDINFOW = (WM_USER + 11)
    RB_GETBANDCOUNT = (WM_USER + 12)
    RB_GETROWCOUNT = (WM_USER + 13)
    RB_GETROWHEIGHT = (WM_USER + 14)
#If (WIN32_IE >= IE4) Then
    RB_IDTOINDEX = (WM_USER + 16)     ' wParam == id
    RB_GETTOOLTIPS = (WM_USER + 17)
    RB_SETTOOLTIPS = (WM_USER + 18)
    RB_SETBKCOLOR = (WM_USER + 19)    ' sets the default BK color
    RB_GETBKCOLOR = (WM_USER + 20)    ' defaults to CLR_NONE
    RB_SETTEXTCOLOR = (WM_USER + 21)
    RB_GETTEXTCOLOR = (WM_USER + 22)  ' defaults to 0
    RB_SIZETORECT = (WM_USER + 23)    ' resize the rebar/break bands and such to this rect (lparam)
#End If ' IE4
    
    RB_SETCOLORSCHEME = CCM_SETCOLORSCHEME   ' lParam is color scheme
    RB_GETCOLORSCHEME = CCM_GETCOLORSCHEME   ' fills in COLORSCHEME pointed to by lParam
    
#If UNICODE Then
    RB_INSERTBAND = RB_INSERTBANDW
    RB_SETBANDINFO = RB_SETBANDINFOW
#Else
    RB_INSERTBAND = RB_INSERTBANDA
    RB_SETBANDINFO = RB_SETBANDINFOA
#End If
    
#If (WIN32_IE >= IE4) Then
    ' for manual drag control
    RB_BEGINDRAG = (WM_USER + 24)
    RB_ENDDRAG = (WM_USER + 25)
    RB_DRAGMOVE = (WM_USER + 26)
    RB_GETBARHEIGHT = (WM_USER + 27)
    RB_GETBANDINFOW = (WM_USER + 28)
    RB_GETBANDINFOA = (WM_USER + 29)
    
#If UNICODE Then
    RB_GETBANDINFO = RB_GETBANDINFOW
#Else
    RB_GETBANDINFO = RB_GETBANDINFOA
#End If
    
    RB_MINIMIZEBAND = (WM_USER + 30)
    RB_MAXIMIZEBAND = (WM_USER + 31)
    
    RB_GETDROPTARGET = (CCM_GETDROPTARGET)
    
    RB_GETBANDBORDERS = (WM_USER + 34) ' returns in lparam = lprc the amount of edges added to band wparam
    
    RB_SHOWBAND = (WM_USER + 35)         ' show/hide band
    RB_SETPALETTE = (WM_USER + 37)
    RB_GETPALETTE = (WM_USER + 38)
    RB_MOVEBAND = (WM_USER + 39)
    
    RB_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT
    RB_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT
#End If     ' IE4
#If (WIN32_IE >= IE5) Then
    RB_SETBANDFOCUS = (WM_USER + 40)  ' (UINT) wParam == band index lParam == TRUE/FALSE returns TRUE if gave band focus, else FALSE
    RB_GETBANDFOCUS = (WM_USER + 41)  ' returns index of band with focus (-1 if none)
    RB_CYCLEFOCUS = (WM_USER + 42)    ' (UINT) wParam == band index (BOOL) lParam == back/forward returns index of band that got focus (-1 if none)
    RB_SETEXTENDEDSTYLE = (WM_USER + 43) ' ??
    RB_PUSHCHEVRON = (WM_USER + 43)
#End If     ' IE5
  End Enum
  
  Public Enum ReBarNotifications
    RBN_HEIGHTCHANGE = (RBN_FIRST - 0)
    RBN_GETOBJECT = (RBN_FIRST - 1) ' UNUSED
    RBN_LAYOUTCHANGED = (RBN_FIRST - 2)
    RBN_AUTOSIZE = (RBN_FIRST - 3)
    RBN_BEGINDRAG = (RBN_FIRST - 4)
    RBN_ENDDRAG = (RBN_FIRST - 5)
    RBN_DELETINGBAND = (RBN_FIRST - 6)
    RBN_DELETEDBAND = (RBN_FIRST - 7)
    RBN_CHILDSIZE = (RBN_FIRST - 8)
    RBN_CHEVRONPUSHED = (RBN_FIRST - 10)
    RBN_MINMAX = (RBN_FIRST - 21)
  End Enum
  
  Public Enum ReBarStyles
    RBS_TOOLTIPS = &H100
    RBS_VARHEIGHT = &H200
    RBS_BANDBORDERS = &H400
    RBS_FIXEDORDER = &H800
#If (WIN32_IE >= IE4) Then
    RBS_REGISTERDROP = &H1000
    RBS_AUTOSIZE = &H2000
    RBS_VERTICALGRIPPER = &H4000
    RBS_DBLCLKTOGGLE = &H8000&
#End If
  End Enum
  
  Public Enum ReBarExStyles
    RBS_EX_OFFICE9 = &H1
  End Enum
  
  Public Const RBIM_IMAGELIST = &H1
  Public Type REBARINFO
    cbSize As Integer
    fMask As Integer
    himl As Long
  End Type
  
#If (WIN32_IE >= IE4) Then
  Public Type RB_HITTESTINFO
    pt As POINTAPI
    Flags As Long
    iBand As Long
  End Type
#End If
  
  Public Type NMRB_SECRET
    hdr As NMHDR
    hWndBandChild As Long
  End Type
  
#If (WIN32_IE >= IE4) Then
  Public Type NMREBARCHILDSIZE
    hdr As NMHDR
    uBand As Long
    wID As Long
    rcChild As RECT
    rcBand As RECT
  End Type
  
  Public Type NMREBAR
    hdr As NMHDR
    dwMask As Long
    uBand As Long
    fStyle As Long
    wID As Long
    lParam As Long
  End Type
  
  Public Enum ReBarNotificationFlags
    RBNM_ID = &H1
    RBNM_STYLE = &H2
    RBNM_LPARAM = &H4
  End Enum
  
  Public Type NMRBAUTOSIZE
    hdr As NMHDR
    fChanged As Long
    rcTarget As RECT
    rcActual As RECT
  End Type
#End If

#If (WIN32_IE >= IE5) Then
  Public Type NMREBARCHEVRON
    hdr As NMHDR
    uBand As Long
    wID As Long
    lParam As Long
    rc As RECT
    lParamNM As Long
  End Type
#End If
  
  Public Enum ReBarBandInfoMasks
    RBBIM_STYLE = &H1
    RBBIM_COLORS = &H2
    RBBIM_TEXT = &H4
    RBBIM_IMAGE = &H8
    RBBIM_CHILD = &H10
    RBBIM_CHILDSIZE = &H20
    RBBIM_SIZE = &H40
    RBBIM_BACKGROUND = &H80
    RBBIM_ID = &H100
#If (WIN32_IE >= IE4) Then
    RBBIM_IDEALSIZE = &H200
    RBBIM_LPARAM = &H400
    RBBIM_HEADERSIZE = &H800
#End If
  End Enum
  
  Public Type REBARBANDINFO
    cbSize As Long
    fMask As Long
    fStyle As Long
    clrFore As Long
    clrBack As Long
    lpText As Long
    cch As Long
    iImage As Long
    hWndChild As Long
    cxMinChild As Long
    cyMinChild As Long
    cx As Long
    hbmBack As Long
    wID As Long
#If (WIN32_IE >= IE4) Then
    cyChild As Long
    cyMaxChild As Long
    cyIntegral As Long
    cxIdeal As Long
    lParam As Long
    cxHeader As Long
#End If
  End Type
#End If

Public Property Get ReBarBand_Info(ByVal hWnd As OLE_HANDLE, ByVal Index As Long, ByVal Mask As ReBarBandInfoMasks) As REBARBANDINFO
  ReBarBand_Info.cbSize = LenB(ReBarBand_Info)
  ReBarBand_Info.fMask = Mask
  If SendMessage(hWnd, RB_GETBANDINFO, Index, ReBarBand_Info) = 0 Then Error 383
End Property

Public Property Let ReBarBand_Info(ByVal hWnd As OLE_HANDLE, ByVal Index As Long, ByVal Mask As ReBarBandInfoMasks, NewValue As REBARBANDINFO)
  NewValue.cbSize = LenB(NewValue)
  NewValue.fMask = Mask
  If SendMessage(hWnd, RB_SETBANDINFO, Index, NewValue) = 0 Then Error 394
End Property

#If (WIN32_IE >= IE4) Then
  Public Function ReBarBand_Rect(ByVal hWnd As OLE_HANDLE, ByVal Index As Long) As RECT
    If SendMessage(hWnd, RB_GETRECT, Index, ReBarBand_Rect) = 0 Then Error 383
  End Function
#End If

Public Sub ReBarBand_StyleMod(ByVal hWnd As OLE_HANDLE, ByVal Index As Long, ByVal NewStyle As RbrBandStyles, Optional ByVal Add As Boolean = True)
  Dim Band As REBARBANDINFO
  
  Band = ReBarBand_Info(hWnd, Index, RBBIM_STYLE)
  If Add Then
    Band.fStyle = Band.fStyle Or NewStyle
  Else
    Band.fStyle = Band.fStyle And Not NewStyle
  End If
  ReBarBand_Info(hWnd, Index, RBBIM_STYLE) = Band
End Sub

Public Function ReBar_BandFromhWnd(ByVal hWnd As OLE_HANDLE, ByVal hWndBand As Long) As ReBarBand
  Dim I As Long
  For I = 0 To SendMessage(hWnd, RB_GETBANDCOUNT, 0, ByVal 0) - 1
    If ReBarBand_Info(hWnd, I, RBBIM_CHILD).hWndChild = hWndBand Then
      Set ReBar_BandFromhWnd = ReBar_GetItem(hWnd, I)
      Exit Function
    End If
  Next
End Function

Public Function ReBar_GetItem(ByVal hWnd As OLE_HANDLE, ByVal Index As Long) As ReBarBand
  Set ReBar_GetItem = GetObjFromPtr(-ReBarBand_Info(hWnd, Index, RBBIM_ID).wID)
End Function
