VERSION 5.00
Object = "{42D59A35-B688-11D5-ADA7-009027BF5C2D}#1.0#0"; "X-SubCls.ocx"
Begin VB.UserControl ReBar 
   Appearance      =   0  'Flat
   ClientHeight    =   615
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5445
   EditAtDesignTime=   -1  'True
   FillStyle       =   0  'Solid
   FontTransparent =   0   'False
   HasDC           =   0   'False
   HitBehavior     =   0  'None
   ScaleHeight     =   41
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   363
   ToolboxBitmap   =   "Controls - ReBar.ctx":0000
   Begin SubClassing.EventHandler EventHandler 
      Left            =   0
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
   End
End
Attribute VB_Name = "ReBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "Member0" ,"ReBarBands"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Option Explicit

'==================================================================
'
' ReBar Control Class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================



'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?


'----------------------------------------------------------
' Current Properties

Private CurhWnd As Long
Private CurResizing As Boolean
#If (WIN32_IE >= IE4) Then
  Private CurSmartSize As Boolean
  Private CurForeColor As OLE_COLOR
  Private CurBackColor As OLE_COLOR
  Private CurBandHighLight As OLE_COLOR
  Private CurBandShadow As OLE_COLOR
#End If
Private RB_Bands As ReBarBands


'----------------------------------------------------------
' Public Enums

Public Enum RbrBorderStyle
  rbrBorderStyleNone = 0          ' And Not RbrBorderStyle*
  rbrBorderStyleSimple = 1        ' WS_BORDER
  rbrBorderStyleThin = 2          ' WS_EX_STATICEDGE
  rbrBorderStyleBig = 4           ' WS_EX_CLIENTEDGE
  rbrBorderStyleRaised = 8        ' WS_THICKFRAME
End Enum

Public Enum RbrOrientation
  rbrHorizontal = 0
  rbrVertical = 1
#If (WIN32_IE >= IE4) Then
  rbrVertivalGripper = 2
#End If
End Enum

#If (WIN32_IE >= IE4) Then
  Public Enum RbrMinMaxBandEvent
    rbrBandSingleClick = 0
    rbrBandDoubleClick = 1
  End Enum
#End If

Public Enum RbrCustomColorConstants
  rbrColorDefault = &HFF000000
  rbrColorNone = &HFFFFFFFF
End Enum

#If (WIN32_IE >= IE4) Then
  Public Enum RbrHitTestPos
    rbrHitTestNoWhere = &H1   ' RBHT_NOWHERE
    rbrHitTestCaption = &H2   ' RBHT_CAPTION
    rbrHitTestClient = &H3    ' RBHT_CLIENT
    rbrHitTestGrabber = &H4   ' RBHT_GRABBER
#If (WIN32_IE >= IE5) Then
    rbrHitTestChevron = &H8   ' RBHT_CHEVRON
#End If
  End Enum
#End If

Public Enum RbrButtonIndex
  rbrButtonLeft = 0
  rbrButtonRight = 1
End Enum

Public Enum RbrSecretNotifications
  RBN_CHILD_ATTACH = &HF0F0F0F0 + 1
  RBN_CHILD_DETACH = &HF0F0F0F0 + 2
End Enum

#If (WIN32_IE >= IE4) Then
  Public Enum RbrBandDragMouseFlags
    rbrDragUseCurrentPos = -1    ' do it yourself.
    rbrDragUseSavedData = -2     '  use what you had saved before
  End Enum
#End If

'----------------------------------------------------------
' Events

Public Event BandClick(ByVal Band As ReBarBand, ByVal MouseButton As RbrButtonIndex)
Attribute BandClick.VB_Description = "Occures when the user clicks on a certain band in the rebar."
Public Event BandDblClick(ByVal Band As ReBarBand, ByVal MouseButton As RbrButtonIndex)
Attribute BandDblClick.VB_Description = "Occures when the user clicks fast on a band twice."
Public Event BandHitEnter(ByVal Band As ReBarBand)
Attribute BandHitEnter.VB_Description = "Occures when enter is pressed on a band."
Public Event BandGotFocus(ByVal Band As ReBarBand)
Attribute BandGotFocus.VB_Description = "Occures when a rebar band gains focus."
Public Event BandLostFocus(ByVal Band As ReBarBand)
Attribute BandLostFocus.VB_Description = "Occures when a band loses the focus."
Public Event BandMouseMove(ByVal Band As ReBarBand)
Attribute BandMouseMove.VB_Description = "Occures when the mouse hovers over a band."

Public Event ChangedLayout()
Attribute ChangedLayout.VB_Description = "Occures when the band layout is changed."
Public Event ChangedHeight()
Attribute ChangedHeight.VB_Description = "Occures when the height of the rebar is changed, caused by band adding/deleting/dragging."
Attribute ChangedHeight.VB_MemberFlags = "200"
Public Event BandMinMax(ByRef Allow As Boolean)
Attribute BandMinMax.VB_Description = "Occures when a band minimizes or maximizes. You can disallow the event."

#If (WIN32_IE >= IE4) Then
  Public Event BandReleaseCapture(ByVal Band As ReBarBand)
Attribute BandReleaseCapture.VB_Description = "Occures when the mouse capture is releases for a band."
  Public Event AutoResize(ByVal Changed As Boolean, ByVal TargetLeft As Long, ByVal TargetTop As Long, ByVal TargetWidth As Long, ByVal TargetHeight As Long, ByVal ActualLeft As Long, ByVal ActualTop As Long, ByVal ActualWidth As Long, ByVal ActualHeight As Long)
Attribute AutoResize.VB_Description = "Auto resizes the rebar."
  Public Event DragInitialize(ByVal Band As ReBarBand, ByRef Allow As Boolean)
Attribute DragInitialize.VB_Description = "Occures when a dragging session is initialized."
  Public Event DragTerminate(ByVal Band As ReBarBand)
Attribute DragTerminate.VB_Description = "Occures when a dragging session is terminated."
  Public Event BandDeleting(ByVal Band As ReBarBand)
Attribute BandDeleting.VB_Description = "Occures when a band is about to be deleted."
  Public Event BandDeleted(ByVal BandID As Long, ByVal hWndChild As Long)
Attribute BandDeleted.VB_Description = "Occures when a band is deleted."
  Public Event ResizingChild(ByVal Band As ReBarBand, ByRef ChildLeftPtr As Long, ByRef ChildTopPtr As Long, ByRef ChildWidthPtr As Long, ByRef ChildHeightPtr As Long, ByVal BandNewLeft As Long, ByVal BandNewTop As Long, ByVal BandNewWidth As Long, ByVal BandNewHeight As Long)
Attribute ResizingChild.VB_Description = "Occures when a band's child is about to be resized."
#End If
#If (WIN32_IE >= IE5) Then
  Public Event ChevronPushed(ByVal Band As ReBarBand, ByVal AbsReBarLeft As Long, ByVal AbsReBarTop As Long, ByVal ChevronLeft As Long, ByVal ChevronTop As Long, ByVal ChevronWidth As Long, ByVal ChevronHeight As Long, ByVal FirstInvisibleButton As Long, ByVal EventFromUser As Boolean)
Attribute ChevronPushed.VB_Description = "Occures when a chevron is pushed on a band. You're supposed to redirect the event to the band's child. (like a toolbar/menubar control)."
#End If


'===========================================================


'----------------------------------------------------------
' Class Interface

Private Sub UserControl_Initialize()
  Dim InitCCEx As tagInitCommonControlsEx
  InitCCEx.lngSize = LenB(InitCCEx)
  ' Load: ReBar ... Toolbar, Tooltip control, Statusbar, Trackbar ... ComboBoxEx ... Header, Hotkey, Listview, Progressbar, Statusbar, Tab, Tooltip, Toolbar, Trackbar, Treeview, Up-down
  InitCCEx.lngICC = ICC_BAR_CLASSES Or ICC_COOL_CLASSES Or ICC_USEREX_CLASSES Or ICC_WIN95_CLASSES
  Call InitCommonControlsEx(InitCCEx)
End Sub

Private Sub UserControl_InitProperties()
#If (WIN32_IE >= IE4) Then
  CurSmartSize = True
#End If
  Call ReBar_Create
#If (WIN32_IE >= IE4) Then
  Me.BackColor = vbButtonFace
  Me.ForeColor = vbButtonText
#End If
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_SHOWWINDOW))
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  If CurhWnd = 0 Then Call ReBar_Create
  Me.BandBorders = PropBag.ReadProperty("BandBorders", True)
  Me.Enabled = PropBag.ReadProperty("Enabled", True)
  Me.FixedOrder = PropBag.ReadProperty("FixedOrder", False)
  Me.Orientation = PropBag.ReadProperty("Orientation", rbrHorizontal)
  Me.VarBandHeight = PropBag.ReadProperty("VarBandHeight", True)
#If (WIN32_IE >= IE4) Then
  Me.AutoSizeBands = PropBag.ReadProperty("AutoSizeBands", False)
  Me.BackColor = PropBag.ReadProperty("BackColor", vbButtonFace)
  Me.ForeColor = PropBag.ReadProperty("ForeColor", vbButtonText)
  Me.MinMaxEvent = PropBag.ReadProperty("MinMaxEvent", rbrBandDoubleClick)
  Me.SmartResize = PropBag.ReadProperty("SmartResize", True)
#Else
  ' If we don't set this value, the rebar failes to redraw correctry
  ' on systems that do have WIN32_IE >= IE4, even if we didn't compile
  ' the project for that ie version. (RB_SETBKCOLOR = (WM_USER + 19))
  Call SendMessage(CurhWnd, (WM_USER + 19), 0, ByVal CoolBar_CColor(vbButtonFace))
#End If
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_SHOWWINDOW))
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  Call PropBag.WriteProperty("BandBorders", Me.BandBorders, True)
  Call PropBag.WriteProperty("Enabled", Me.Enabled, True)
  Call PropBag.WriteProperty("FixedOrder", Me.FixedOrder, False)
  Call PropBag.WriteProperty("Orientation", Me.Orientation, rbrHorizontal)
  Call PropBag.WriteProperty("VarBandHeight", Me.VarBandHeight, True)
#If (WIN32_IE >= IE4) Then
  Call PropBag.WriteProperty("AutoSizeBands", Me.AutoSizeBands, False)
  Call PropBag.WriteProperty("BackColor", Me.BackColor, vbButtonFace)
  Call PropBag.WriteProperty("ForeColor", Me.ForeColor, vbButtonText)
  Call PropBag.WriteProperty("MinMaxEvent", Me.MinMaxEvent, rbrBandDoubleClick)
  Call PropBag.WriteProperty("BandHighlightColor", Me.BandHighlightColor, rbrColorDefault)
  Call PropBag.WriteProperty("BandShadowColor", Me.BandShadowColor, rbrColorDefault)
  Call PropBag.WriteProperty("SmartResize", Me.SmartResize, True)
#End If
End Sub

Private Sub UserControl_Resize()
  If Not CurResizing Then
    CurResizing = True ' Avoid recursive calls from usercontrol's winproc
    Dim NewSize As RECT
    
    ' Read rect of parent user control, and resize rebar to it.
    Call GetClientRect(UserControl.hWnd, NewSize)
    Call SetWindowPos(CurhWnd, 0, NewSize.Left, NewSize.Top - 2, NewSize.Right - NewSize.Left, NewSize.Bottom - NewSize.Top, SWP_NOMOVE Or SWP_NOACTIVATE)
    
#If (WIN32_IE >= IE4) Then
    ' Let the rebar change the layout of it's bands (if you wanted to)
    If CurSmartSize Then Call SendMessage(CurhWnd, RB_SIZETORECT, 0, NewSize)
#End If
    
    ' Resize the usercontrol to the new rebar window size (the rebar will resize to fit it's bands)
    Call GetClientRect(CurhWnd, NewSize)
    If Me.Orientation = rbrHorizontal Then
      UserControl.Height = UserControl.ScaleY(NewSize.Bottom - NewSize.Top + 4, vbPixels, vbTwips)
    Else
      UserControl.Width = UserControl.ScaleX(NewSize.Right - NewSize.Left + 4, vbPixels, vbTwips)
    End If
    
    ' Redraw window.
    Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_FRAMECHANGED)
    CurResizing = False
  End If
End Sub

Private Sub UserControl_Terminate()
  If EventHandler.Attached(UserControl.hWnd) Then EventHandler.Attached(UserControl.hWnd) = False
  Set RB_Bands = Nothing
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_HIDEWINDOW Or SWP_FRAMECHANGED Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOSIZE)
  Call DestroyWindow(CurhWnd)
  CurhWnd = 0
End Sub

'----------------------------------------------------------
' Event Handling

Private Sub EventHandler_ReceivedMessage(ByVal hWnd As Long, ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long, ReturnMessage As SubClassing.EventResultMessage)
  Dim I As Long
  Dim J As Long
  Dim Allow As Boolean
  Dim Band As ReBarBand
  Dim Button As ToolBarButton
  Dim Size1 As RECT
  Dim Size2 As RECT
  Dim Size3 As RECT
  Dim Text As String
  Dim ByteStr() As Byte
  Dim NMHDR As NMHDR
#If (WIN32_IE >= IE4) Then
  Dim NMRBR As NMREBAR
  Dim NMAUTO As NMRBAUTOSIZE
  Dim NMRESIZE As NMREBARCHILDSIZE
  Dim NMTOOLTIP As NMTTDISPINFO
#End If
#If (WIN32_IE >= IE5) Then
  Dim NMCHEVRON As NMREBARCHEVRON
#End If
  Dim NMSECRET As NMRB_SECRET
  
  ReturnMessage = SubClassing.evtCallPrevWinProc
  
  Select Case WindowMessage
#If (WIN32_IE >= IE4) Then
    Case WM_SYSCOLORCHANGE
      ' This need to be done when we set the color explicitly
      Me.BackColor = Me.BackColor
      Me.ForeColor = Me.ForeColor
      ReturnMessage = SubClassing.evtHandled
#End If
    Case WM_PAINT
      Call SendMessage(CurhWnd, WM_PAINT, 0, ByVal 0)
      For I = 0 To SendMessage(CurhWnd, RB_GETBANDCOUNT, 0, ByVal 0) - 1
        Call SendMessage(ReBarBand_Info(CurhWnd, I, RBBIM_CHILD).hWndChild, WM_PAINT, 0, ByVal 0)
      Next
    Case WM_NOTIFY
      Call CopyMemory(NMHDR, ByVal lParam, Len(NMHDR))
      Select Case NMHDR.code
        ' COMMON NOTIFICATIONS!
        
        Case NM_CUSTOMDRAW
          ReturnMessage = SubClassing.evtCallPrevWinProc
          Exit Sub
#If (WIN32_IE >= IE4) Then
        Case NM_NCHITTEST
          ReturnMessage = SubClassing.evtCallPrevWinProc
          Exit Sub
        Case NM_KEYDOWN, NM_SETCURSOR, NM_CHAR
          Debug.Assert False
#End If
#If (WIN32_IE >= IE401) Then
        Case NM_TOOLTIPSCREATED
          ReturnMessage = SubClassing.evtCallPrevWinProc
          Exit Sub
#End If
#If (WIN32_IE >= IE5) Then
        Case NM_LDOWN, NM_RDOWN
          ReturnMessage = SubClassing.evtCallPrevWinProc
          Exit Sub
#End If
        Case NM_OUTOFMEMORY
          Error 7
        Case NM_CLICK:            RaiseEvent BandClick(ReBar_BandFromhWnd(CurhWnd, NMHDR.hWndFrom), rbrButtonLeft)
        Case NM_RCLICK:           RaiseEvent BandClick(ReBar_BandFromhWnd(CurhWnd, NMHDR.hWndFrom), rbrButtonRight)
        Case NM_DBLCLK:           RaiseEvent BandDblClick(ReBar_BandFromhWnd(CurhWnd, NMHDR.hWndFrom), rbrButtonLeft)
        Case NM_RDBLCLK:          RaiseEvent BandDblClick(ReBar_BandFromhWnd(CurhWnd, NMHDR.hWndFrom), rbrButtonRight)
        Case NM_RETURN:           RaiseEvent BandHitEnter(ReBar_BandFromhWnd(CurhWnd, NMHDR.hWndFrom))
        Case NM_SETFOCUS:         RaiseEvent BandGotFocus(ReBar_BandFromhWnd(CurhWnd, NMHDR.hWndFrom))
        Case NM_KILLFOCUS:        RaiseEvent BandLostFocus(ReBar_BandFromhWnd(CurhWnd, NMHDR.hWndFrom))
        Case NM_HOVER:            RaiseEvent BandMouseMove(ReBar_BandFromhWnd(CurhWnd, NMHDR.hWndFrom))
#If (WIN32_IE >= IE4) Then
        Case NM_RELEASEDCAPTURE:  RaiseEvent BandReleaseCapture(ReBar_BandFromhWnd(CurhWnd, NMHDR.hWndFrom))
#End If
        
        ' REBAR NOTIFICATIONS!
        
        Case RBN_GETOBJECT
          Debug.Assert False
        Case RBN_HEIGHTCHANGE
          Call GetWindowRect(CurhWnd, Size1)
          If Me.Orientation = rbrHorizontal Then
            UserControl.Height = UserControl.ScaleY(Size1.Bottom - Size1.Top, vbPixels, vbTwips)
          Else
            UserControl.Width = UserControl.ScaleX(Size1.Right - Size1.Left, vbPixels, vbTwips)
          End If
          Call SendMessage(CurhWnd, WM_SIZE, 0, ByVal 0)
          RaiseEvent ChangedHeight
        Case RBN_LAYOUTCHANGED
          RaiseEvent ChangedLayout
#If (WIN32_IE >= IE4) Then
        Case RBN_AUTOSIZE
          Call CopyMemory(NMAUTO, ByVal lParam, LenB(NMAUTO))
          RaiseEvent AutoResize(NMAUTO.fChanged, NMAUTO.rcTarget.Left, NMAUTO.rcTarget.Top, NMAUTO.rcTarget.Right - NMAUTO.rcTarget.Left, NMAUTO.rcTarget.Bottom - NMAUTO.rcTarget.Top, NMAUTO.rcActual.Left, NMAUTO.rcActual.Top, NMAUTO.rcActual.Right - NMAUTO.rcActual.Left, NMAUTO.rcActual.Bottom - NMAUTO.rcActual.Top)
        Case RBN_BEGINDRAG
          Call CopyMemory(NMRBR, ByVal lParam, LenB(NMRBR))
          Allow = True
          RaiseEvent DragInitialize(ReBar_GetItem(CurhWnd, NMRBR.uBand), Allow)
          ReturnMessage = IIf(Allow, 0, 1)
        Case RBN_ENDDRAG
          Call CopyMemory(NMRBR, ByVal lParam, LenB(NMRBR))
          RaiseEvent DragTerminate(ReBar_GetItem(CurhWnd, NMRBR.uBand))
        Case RBN_DELETINGBAND ' We could restore the position/parent/stylebits of the control here...
          Call CopyMemory(NMRBR, ByVal lParam, Len(NMRBR))
          Set Band = ReBar_GetItem(CurhWnd, NMRBR.uBand)
          Call SetProp(CurhWnd, RBR_PROP_BANDHWND & NMRBR.wID, Band.hWnd)
          RaiseEvent BandDeleting(Band)
        Case RBN_DELETEDBAND
          Call CopyMemory(NMRBR, ByVal lParam, Len(NMRBR))
          I = GetProp(CurhWnd, RBR_PROP_BANDHWND & NMRBR.wID)
          If I <> 0 Then
            Call SetParent(I, GetProp(I, RBR_PROP_PARENT))
            NMSECRET.hdr.code = RbrSecretNotifications.RBN_CHILD_DETACH
            NMSECRET.hdr.hWndFrom = CurhWnd
            NMSECRET.hdr.IdFrom = NMRBR.wID
            NMSECRET.hWndBandChild = I
            Call SendMessage(I, WM_NOTIFY, 0, NMSECRET)
          Else
            Debug.Assert False
          End If
          RaiseEvent BandDeleted(NMRBR.wID, I)
          Call RemoveProp(CurhWnd, RBR_PROP_BANDHWND & NMRBR.wID)
        Case RBN_CHILDSIZE ' ChildResizing
          Call CopyMemory(NMRESIZE, ByVal lParam, Len(NMRESIZE))
          LSet Size1 = NMRESIZE.rcChild
          Size1.Right = Size1.Right - Size1.Left
          Size1.Bottom = Size1.Bottom - Size1.Top
          If NMRBR.uBand <> -1 Then Set Band = ReBar_GetItem(CurhWnd, NMRBR.uBand)
          RaiseEvent ResizingChild(Band, Size1.Left, Size1.Top, Size1.Right, Size1.Bottom, NMRESIZE.rcBand.Left, NMRESIZE.rcBand.Top, NMRESIZE.rcBand.Right - NMRESIZE.rcBand.Left, NMRESIZE.rcBand.Bottom - NMRESIZE.rcBand.Top)
          Size1.Right = Size1.Right + Size1.Left
          Size1.Bottom = Size1.Bottom + Size1.Top
          LSet NMRESIZE.rcChild = Size1
#End If
        Case RBN_MINMAX
          Allow = True
          RaiseEvent BandMinMax(Allow)
          ReturnMessage = IIf(Allow, 0, 1)
#If (WIN32_IE >= IE5) Then
        Case RBN_CHEVRONPUSHED
          Call CopyMemory(NMCHEVRON, ByVal lParam, Len(NMCHEVRON))
          Set Band = ReBar_GetItem(CurhWnd, NMCHEVRON.uBand)
          Allow = False
          If SendMessage(CurhWnd, RB_GETRECT, NMCHEVRON.uBand, Size1) Then
            If NMCHEVRON.rc.Left < Size1.Right Then Size1.Right = NMCHEVRON.rc.Left
            Size1.Right = Size1.Right - 4
            Text = Space(256)
            J = Band.hWnd
            I = GetClassName(J, Text, Len(Text))
            If I Then
              Text = Left(Text, I)
              If InStr(1, Text, "Toolbar", vbTextCompare) Then
                For I = 0 To SendMessage(J, TB_BUTTONCOUNT, 0, ByVal 0) - 1
                  If SendMessage(J, TB_GETITEMRECT, I, Size2) Then
                    Call MapWindowPoints(J, CurhWnd, Size2, 2)
                    Call IntersectRect(Size3, Size1, Size2)
                    If EqualRect(Size2, Size3) = 0 Then
                      I = I + 1
                      Allow = True
                      Exit For
                    End If
                  End If
                Next
              End If
            End If
          End If
          NMCHEVRON.rc.Left = NMCHEVRON.rc.Left + 2
          NMCHEVRON.rc.Right = NMCHEVRON.rc.Right + 2
          NMCHEVRON.rc.Top = NMCHEVRON.rc.Top + 2
          NMCHEVRON.rc.Bottom = NMCHEVRON.rc.Bottom + 2
          If GetWindowRect(CurhWnd, Size1) <> 0 Then
            If Allow Then
              RaiseEvent ChevronPushed(Band, Size1.Left, Size1.Top, NMCHEVRON.rc.Left, NMCHEVRON.rc.Top, NMCHEVRON.rc.Right - NMCHEVRON.rc.Left, NMCHEVRON.rc.Bottom - NMCHEVRON.rc.Top, I, NMCHEVRON.lParam <> 0)
            Else
              RaiseEvent ChevronPushed(Band, Size1.Left, Size1.Top, NMCHEVRON.rc.Left, NMCHEVRON.rc.Top, NMCHEVRON.rc.Right - NMCHEVRON.rc.Left, NMCHEVRON.rc.Bottom - NMCHEVRON.rc.Top, 0, NMCHEVRON.lParam <> 0)
            End If
          End If
#End If
      End Select
  End Select
End Sub


'===========================================================


'----------------------------------------------------------
' Special Properties/Methods

Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns the handle of the rebar control."
Attribute hWnd.VB_UserMemId = 0
Attribute hWnd.VB_MemberFlags = "200"
  hWnd = CurhWnd
End Property

Public Sub AboutBox()
Attribute AboutBox.VB_Description = "Displays an about dialog box."
Attribute AboutBox.VB_UserMemId = -552
Attribute AboutBox.VB_MemberFlags = "40"
  frmAbout.Show vbModal
End Sub

Public Sub Refresh()
Attribute Refresh.VB_Description = "Redraws the rebar control."
Attribute Refresh.VB_UserMemId = -550
  Dim ReBarSize As RECT
  Dim ParentSize As RECT
  Call UserControl_Resize
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_FRAMECHANGED))
End Sub

Public Property Get ScaleMode() As ScaleModeConstants
Attribute ScaleMode.VB_Description = "Returns the currently used scaleing mode."
  ScaleMode = vbPixels
End Property

Public Property Get ParentScaleMode() As ScaleModeConstants
  Select Case LCase(UserControl.Ambient.ScaleUnits)
    Case "centimeter":        ParentScaleMode = vbCentimeters
    Case "character":         ParentScaleMode = vbCharacters
    Case "containerposition": ParentScaleMode = vbContainerPosition
    Case "containersize":     ParentScaleMode = vbContainerSize
    Case "himetric":          ParentScaleMode = vbHimetric
    Case "inch":              ParentScaleMode = vbInches
    Case "millimeter":        ParentScaleMode = vbMillimeters
    Case "pixel":             ParentScaleMode = vbPixels
    Case "point":             ParentScaleMode = vbPoints
    Case "twip":              ParentScaleMode = vbTwips
    Case "user":              ParentScaleMode = vbUser
    Case Else: Debug.Assert False
  End Select
End Property



'----------------------------------------------------------
' Bands

Public Property Get Bands() As ReBarBands
Attribute Bands.VB_Description = "Containes a band collection object."
  Set Bands = RB_Bands
End Property

#If (WIN32_IE >= IE4) Then
  Public Sub BandDragStart(ByVal BandIndex As Long, Optional ByVal MouseFlag As RbrBandDragMouseFlags = rbrDragUseCurrentPos)
Attribute BandDragStart.VB_Description = "Starts a band dragging session."
    If BandIndex < 1 Or BandIndex > SendMessage(CurhWnd, RB_GETBANDCOUNT, 0, ByVal 0) Then Error 5
    Call SendMessage(CurhWnd, RB_BEGINDRAG, BandIndex - 1, ByVal MouseFlag)
  End Sub
  
  Public Sub BandDragStartEx(ByVal BandIndex As Long, Optional ByVal PtMouseX As Integer = -1, Optional ByVal PtMouseY As Integer = -1)
Attribute BandDragStartEx.VB_Description = "Initializes a band drag session. If the mouse coordinates are omitted, the mouse position will be used!"
    Dim DWORD As DWORD
    Dim DWORD_LONG As DWORD_LONG
    DWORD.LoWord = PtMouseX
    DWORD.HiWord = PtMouseY
    LSet DWORD_LONG = DWORD
    If BandIndex < 1 Or BandIndex > SendMessage(CurhWnd, RB_GETBANDCOUNT, 0, ByVal 0) Then Error 5
    Call SendMessage(CurhWnd, RB_BEGINDRAG, BandIndex - 1, ByVal DWORD_LONG.N)
  End Sub
  
  Public Sub BandDragTo(Optional ByVal MouseFlag As RbrBandDragMouseFlags = rbrDragUseCurrentPos)
Attribute BandDragTo.VB_Description = "Drags a band to a position."
    Call SendMessage(CurhWnd, RB_DRAGMOVE, 0, ByVal MouseFlag)
  End Sub
  
  Public Sub BandDragToEx(Optional ByVal PtMouseX As Integer = -1, Optional ByVal PtMouseY As Integer = -1)
Attribute BandDragToEx.VB_Description = "Drags a band to a specific area when the rebar band drag session has been initialized."
    Dim DWORD As DWORD
    Dim DWORD_LONG As DWORD_LONG
    DWORD.LoWord = PtMouseX
    DWORD.HiWord = PtMouseY
    LSet DWORD_LONG = DWORD
    Call SendMessage(CurhWnd, RB_DRAGMOVE, 0, ByVal DWORD_LONG.N)
  End Sub
  
  Public Sub BandDragEnd()
Attribute BandDragEnd.VB_Description = "Terminates a band drag session."
    Call SendMessage(CurhWnd, RB_ENDDRAG, 0, ByVal 0)
  End Sub
  
  Public Function HitTest(ByVal PtClientX As Long, ByVal PtClientY As Long, ByRef FlagPtr As RbrHitTestPos) As ReBarBand
Attribute HitTest.VB_Description = "This method will find a rebar band from a specific client coordinate."
    Dim BandIndex As Long
    Dim HitInfo As RB_HITTESTINFO
    HitInfo.pt.X = PtClientX
    HitInfo.pt.Y = PtClientY
    BandIndex = SendMessage(CurhWnd, RB_HITTEST, 0, HitInfo)
    'BandIndex = HitInfo.iBand
    FlagPtr = HitInfo.Flags
    If BandIndex = -1 Then
      Set HitTest = Nothing
    Else
      Set HitTest = ReBar_GetItem(CurhWnd, BandIndex)
    End If
  End Function
#End If

'----------------------------------------------------------
' Other Properties

Public Property Get RowCount() As Long
Attribute RowCount.VB_Description = "Returns the current number of band-rows."
  RowCount = SendMessage(CurhWnd, RB_GETROWCOUNT, 0, ByVal 0)
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get BarHeight() As Long
Attribute BarHeight.VB_Description = "Returns the height of the rebar."
    BarHeight = SendMessage(CurhWnd, RB_GETBARHEIGHT, 0, ByVal 0) + 4
  End Property
#End If

Public Property Get hImageList() As OLE_HANDLE
Attribute hImageList.VB_Description = "Returns/Sets a handle that defines the image-list, used for some rebar control graphics."
Attribute hImageList.VB_ProcData.VB_Invoke_Property = ";Misc"
Attribute hImageList.VB_MemberFlags = "400"
  Dim BarInfo As REBARINFO
  BarInfo.cbSize = LenB(BarInfo)
  BarInfo.fMask = RBIM_IMAGELIST
  If SendMessage(CurhWnd, RB_GETBARINFO, 0, BarInfo) = 0 Then Error 5
  hImageList = BarInfo.himl
End Property

Public Property Let hImageList(ByVal NewValue As OLE_HANDLE)
  Dim BarInfo As REBARINFO
  BarInfo.cbSize = LenB(BarInfo)
  BarInfo.fMask = RBIM_IMAGELIST
  BarInfo.himl = NewValue
  If SendMessage(CurhWnd, RB_SETBARINFO, 0, BarInfo) = 0 Then Error 380
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get hPalette() As OLE_HANDLE
Attribute hPalette.VB_Description = "Returns the GDI-handle to the currently used palette."
    hPalette = SendMessage(CurhWnd, RB_GETPALETTE, 0, ByVal 0)
  End Property
  
  Public Property Let hPalette(ByVal NewValue As OLE_HANDLE)
    Call SendMessage(CurhWnd, RB_SETPALETTE, 0, ByVal NewValue)
  End Property
  
  Public Property Get hWndTooltip() As OLE_HANDLE
Attribute hWndTooltip.VB_Description = "Returns the handle to the tooltip window associated."
Attribute hWndTooltip.VB_MemberFlags = "400"
    hWndTooltip = SendMessage(CurhWnd, RB_GETTOOLTIPS, 0, ByVal 0)
  End Property
  
  Public Property Let hWndTooltip(ByVal NewValue As OLE_HANDLE)
    If IsWindow(NewValue) = 0 And NewValue <> 0 Then Error 380
    Call SendMessage(CurhWnd, RB_SETTOOLTIPS, NewValue, ByVal 0)
  End Property
  
  Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/Sets the background color of the rebar control."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
  '  BackColor = SendMessage(CurhWnd, RB_GETBKCOLOR, 0, ByVal 0)
  '  If BackColor = -1 Then BackColor = vbButtonFace
    BackColor = CurBackColor
  End Property
  
  Public Property Let BackColor(ByVal NewValue As OLE_COLOR)
    Dim PrevColor As OLE_COLOR
    PrevColor = SendMessage(CurhWnd, RB_SETBKCOLOR, 0, ByVal CoolBar_CColor(NewValue))
    CurBackColor = NewValue
    UserControl.BackColor = NewValue
    Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_FRAMECHANGED))
    PropertyChanged "BackColor"
  End Property
  
  Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/Sets the text color for the rebar band captions."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513
  '  ForeColor = SendMessage(CurhWnd, RB_GETTEXTCOLOR, 0, ByVal 0)
  '  If ForeColor = -1 Then ForeColor = vbButtonText
    ForeColor = UserControl.ForeColor
  End Property
  
  Public Property Let ForeColor(ByVal NewValue As OLE_COLOR)
    Dim PrevColor As OLE_COLOR
    Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_HIDEWINDOW))
    PrevColor = SendMessage(CurhWnd, RB_SETTEXTCOLOR, 0, ByVal CoolBar_CColor(NewValue))
    CurForeColor = NewValue
    Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_SHOWWINDOW))
    PropertyChanged "ForeColor"
  End Property
  
  Public Property Get BandHighlightColor() As OLE_COLOR
Attribute BandHighlightColor.VB_Description = "Defines a custom light color for a band."
    BandHighlightColor = CommonControls_ColorScheme(CurhWnd).clrBtnShadow
    If BandHighlightColor = CoolBar_CColor(CurBandShadow) Then BandHighlightColor = CurBandHighLight
  End Property
  
  Public Property Let BandHighlightColor(ByVal NewValue As OLE_COLOR)
    Dim Colors As COLORSCHEME
    Colors = CommonControls_ColorScheme(CurhWnd)
    If NewValue <> rbrColorDefault Then
      Colors.clrBtnHighlight = CoolBar_CColor(NewValue)
      If Colors.clrBtnHighlight = -1 Then Error 380
    Else
      Colors.clrBtnHighlight = NewValue
    End If
    CommonControls_ColorScheme(CurhWnd) = Colors
  End Property
  
  Public Property Get BandShadowColor() As OLE_COLOR
Attribute BandShadowColor.VB_Description = "Defines a custom shadow color for the rebar bands."
Attribute BandShadowColor.VB_MemberFlags = "400"
    BandShadowColor = CommonControls_ColorScheme(CurhWnd).clrBtnShadow
    If BandShadowColor = CoolBar_CColor(CurBandShadow) Then BandShadowColor = CurBandShadow
  End Property
  
  Public Property Let BandShadowColor(ByVal NewValue As OLE_COLOR)
    Dim Colors As COLORSCHEME
    Colors = CommonControls_ColorScheme(CurhWnd)
    If NewValue <> rbrColorDefault Then
      Colors.clrBtnShadow = CoolBar_CColor(NewValue)
      If Colors.clrBtnShadow = -1 Then Error 380
    Else
      Colors.clrBtnShadow = NewValue
    End If
    CommonControls_ColorScheme(CurhWnd) = Colors
  End Property
#End If

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Specifies whether the rebar can respond to user generated events."
  Enabled = IsWindowEnabled(CurhWnd)
End Property

Public Property Let Enabled(ByVal NewValue As Boolean)
  Call EnableWindow(CurhWnd, IIf(NewValue, 1, 0))
  UserControl.Enabled = NewValue
End Property


'----------------------------------------------------------
' Window Style Flags

'Public Property Get UseToolTips() As Boolean
'  UseToolTips = (ReBar_Style And RBS_TOOLTIPS)
'End Property
'
'Public Property Let UseToolTips(ByVal NewValue As Boolean)
'  If NewValue = Me.UseToolTips Then Exit Property
'  call CoolBar_StyleMod(CurhWnd, RBS_TOOLTIPS, NewValue)
'  Call ReBar_Update
'  PropertyChanged "UseToolTips"
'End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get SmartResize() As Boolean
Attribute SmartResize.VB_Description = "Affects the resizing behavour of the rebar."
    SmartResize = CurSmartSize
  End Property
  
  Public Property Let SmartResize(ByVal NewValue As Boolean)
    CurSmartSize = NewValue
  End Property
#End If

Public Property Get BandBorders() As Boolean
Attribute BandBorders.VB_Description = "Determines whether the rebar control displays narrow lines to separate adjacent bands or not."
Attribute BandBorders.VB_ProcData.VB_Invoke_Property = ";Appearance"
  BandBorders = (GetWindowLong(CurhWnd, GWL_STYLE) And RBS_BANDBORDERS)
End Property

Public Property Let BandBorders(ByVal NewValue As Boolean)
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_HIDEWINDOW))
  Call CoolBar_StyleMod(CurhWnd, RBS_BANDBORDERS, NewValue)
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_FRAMECHANGED Or SWP_SHOWWINDOW))
  PropertyChanged "BandBorders"
End Property

Public Property Get FixedOrder() As Boolean
Attribute FixedOrder.VB_Description = "Forces the rebar bands to a specific order."
Attribute FixedOrder.VB_ProcData.VB_Invoke_Property = ";Behavior"
  FixedOrder = (GetWindowLong(CurhWnd, GWL_STYLE) And RBS_FIXEDORDER)
End Property

Public Property Let FixedOrder(ByVal NewValue As Boolean)
  Call CoolBar_StyleMod(CurhWnd, RBS_FIXEDORDER, NewValue)
  PropertyChanged "FixedOrder"
End Property

Public Property Get VarBandHeight() As Boolean
Attribute VarBandHeight.VB_Description = "Determines whether the rebar bands can have different heights or not."
Attribute VarBandHeight.VB_ProcData.VB_Invoke_Property = ";Behavior"
  VarBandHeight = (GetWindowLong(CurhWnd, GWL_STYLE) And RBS_VARHEIGHT)
End Property

Public Property Let VarBandHeight(ByVal NewValue As Boolean)
  Call CoolBar_StyleMod(CurhWnd, RBS_VARHEIGHT, NewValue)
  PropertyChanged "VarBandHeight"
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get MinMaxEvent() As RbrMinMaxBandEvent
Attribute MinMaxEvent.VB_Description = "Defines what triggers a minmax event."
    MinMaxEvent = Abs(CLng(CBool(GetWindowLong(CurhWnd, GWL_STYLE) And RBS_DBLCLKTOGGLE)))
  End Property
  
  Public Property Let MinMaxEvent(ByVal NewValue As RbrMinMaxBandEvent)
    If NewValue < rbrBandSingleClick Or NewValue > rbrBandDoubleClick Then Error 380
    Call CoolBar_StyleMod(CurhWnd, RBS_DBLCLKTOGGLE, CBool(NewValue))
    PropertyChanged "MinMaxEvent"
  End Property
  
  Public Property Get AutoSizeBands() As Boolean
Attribute AutoSizeBands.VB_Description = "When true, the rebar control will automatically change the layout of the bands when the size or position of the control changes."
Attribute AutoSizeBands.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute AutoSizeBands.VB_UserMemId = -500
    AutoSizeBands = (GetWindowLong(CurhWnd, GWL_STYLE) And RBS_AUTOSIZE)
  End Property
  
  Public Property Let AutoSizeBands(ByVal NewValue As Boolean)
    Call CoolBar_StyleMod(CurhWnd, RBS_AUTOSIZE, NewValue)
    PropertyChanged "AutoSizeBands"
  End Property
#End If

Public Property Get Orientation() As RbrOrientation
Attribute Orientation.VB_Description = "Defines where the rebar is supposed to be positioned."
  Dim Style As ReBarStyles
  
  Style = GetWindowLong(CurhWnd, GWL_STYLE)
  If ((Style And CCS_RIGHT) = CCS_RIGHT) Then
    Orientation = rbrVertical
#If (WIN32_IE >= IE4) Then
    If Style And RBS_VERTICALGRIPPER Then Orientation = rbrVertivalGripper
#End If
  ElseIf ((Style And CCS_LEFT) = CCS_LEFT) Then
    Orientation = rbrVertical
#If (WIN32_IE >= IE4) Then
    If Style And RBS_VERTICALGRIPPER Then Orientation = rbrVertivalGripper
#End If
  ElseIf ((Style And CCS_BOTTOM) = CCS_BOTTOM) Then
    Orientation = rbrHorizontal
  ElseIf ((Style And CCS_TOP) = CCS_TOP) Then
    Orientation = rbrHorizontal
  Else
    Orientation = rbrHorizontal
  End If
End Property

Public Property Let Orientation(ByVal NewValue As RbrOrientation)
  Dim OldValue As RbrOrientation
  Dim OldWidth As Single
  Dim OldHeight As Single
  Dim NewSize As RECT
  
#If (WIN32_IE >= IE4) Then
  If NewValue > rbrVertivalGripper Or NewValue < rbrHorizontal Then Error 380
#End If
  
  ' Hide; we want a complete redraw and no flashes
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_HIDEWINDOW)
  
  CurResizing = True
  OldValue = Me.Orientation
  OldWidth = UserControl.Width
  OldHeight = UserControl.Height
  Call CoolBar_StyleMod(CurhWnd, CCS_VERT, NewValue <> rbrHorizontal)
#If (WIN32_IE >= IE4) Then
  Call CoolBar_StyleMod(CurhWnd, RBS_VERTICALGRIPPER, NewValue = rbrVertivalGripper)
#End If
  
  If NewValue = rbrHorizontal And OldValue <> rbrHorizontal _
  Or NewValue <> rbrHorizontal And OldValue = rbrHorizontal Then
    ' Switch roles of width/height
    UserControl.Width = OldHeight
    UserControl.Height = OldWidth
  End If
  
  ' Read rect of parent user control, and resize rebar to it.
  Call GetClientRect(UserControl.hWnd, NewSize)
  If Me.Orientation = rbrHorizontal Then
    Call SetWindowPos(CurhWnd, 0, NewSize.Left, NewSize.Top - 2, NewSize.Right - NewSize.Left, NewSize.Bottom - NewSize.Top, SWP_NOMOVE Or SWP_NOACTIVATE)
  Else
    Call SetWindowPos(CurhWnd, 0, NewSize.Left - 2, NewSize.Top, NewSize.Right - NewSize.Left, NewSize.Bottom - NewSize.Top, SWP_NOMOVE Or SWP_NOACTIVATE)
  End If
  
  ' Let the rebar change the layout of it's bands (if you wanted to)
#If (WIN32_IE >= IE4) Then
  If CurSmartSize Then Call SendMessage(CurhWnd, RB_SIZETORECT, 0, NewSize)
#End If
  Call SendMessage(UserControl.hWnd, WM_PAINT, 0, ByVal 0)
  
  ' Show
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_SHOWWINDOW)
  CurResizing = False
  Call UserControl_Resize
  RaiseEvent ChangedHeight
End Property




'===========================================================


'----------------------------------------------------------
' ReBar Code

Private Sub ReBar_Create()
  Dim Band As ReBarBand
  Dim StartPos As Long
  
#If (WIN32_IE >= IE4) Then
  CurhWnd = CreateWindowEx(WS_EX_TOOLWINDOW, REBARCLASSNAME, "Xception's controls  - VB5 [ReBar]", WS_CHILD Or WS_BORDER Or WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or CCS_NODIVIDER Or CCS_NOPARENTALIGN Or RBS_BANDBORDERS Or RBS_VARHEIGHT Or RBS_TOOLTIPS Or RBS_DBLCLKTOGGLE, 0, 0, 0, 0, UserControl.hWnd, ICC_COOL_CLASSES, App.hInstance, Null)
#Else
  CurhWnd = CreateWindowEx(WS_EX_TOOLWINDOW, REBARCLASSNAME, "Xception's controls  - VB5 [ReBar]", WS_CHILD Or WS_BORDER Or WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or CCS_NODIVIDER Or CCS_NOPARENTALIGN Or RBS_BANDBORDERS Or RBS_VARHEIGHT Or RBS_TOOLTIPS, 0, 0, 0, 0, UserControl.hWnd, ICC_COOL_CLASSES, App.hInstance, Null)
#End If
  If CurhWnd = 0 Then Err.Raise 336, , "Component not found or not correctly registered: Internet Explorer Rebar"
  Call SendMessage(CurhWnd, RB_SETPARENT, UserControl.hWnd, ByVal 0)
  
  Set RB_Bands = New ReBarBands
  Call RB_Bands.ReBarBand_Create(CurhWnd, UserControl.hWnd, ObjPtr(Me))
  Call UserControl_Resize
  If Not UserControl.Ambient.UserMode Then
    With RB_Bands
      .Add , , "ReBar", , , , , 64, 18
      .Add , , "ReBar", , , , , 64, 18
    End With
  Else
    EventHandler.Attached(UserControl.hWnd) = True
  End If
End Sub
