Attribute VB_Name = "ToolBarDeclarations"
Option Explicit

'==================================================================
'
' Toolbar Declarations
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================


'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?

'------------------------------------------------------------------------
' Declarations

Public Declare Function CreateToolbarEx Lib "comctl32" (ByVal hWnd As Long, ByVal ws As Long, ByVal wID As Long, ByVal nBitmaps As Long, ByVal hBMInst As Long, ByVal wBMID As Long, ByRef lpButtons As TBBUTTON, ByVal iNumButtons As Long, ByVal dxButton As Long, ByVal dyButton As Long, ByVal dxBitmap As Long, ByVal dyBitmap As Long, ByVal uStructSize As Long) As Long
Public Declare Function CreateMappedBitmap Lib "comctl32" (hInstance As Long, idBitmap As Long, wFlags As CreateMappedBitmapFlags, lpColorMap As COLORMAP, iNumMaps As Long) As Long

Public Declare Function IsWindowVisible Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function UnionRect Lib "user32" (lpDestRect As RECT, lpSrc1Rect As RECT, lpSrc2Rect As RECT) As Long
Public Declare Function IsMenu Lib "user32" (ByVal hMenu As Long) As Long

Public Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long

Public Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Public Const TOOLBARCLASSNAME = "ToolbarWindow32"

Public Const TBR_PROP_BUTTONSCOL = "ToolBar_BtnVBCol"

Public Enum ToolBarMessages
  TB_ENABLEBUTTON = (WM_USER + 1)
  TB_CHECKBUTTON = (WM_USER + 2)
  TB_PRESSBUTTON = (WM_USER + 3)
  TB_HIDEBUTTON = (WM_USER + 4)
  TB_INDETERMINATE = (WM_USER + 5)
#If (WIN32_IE >= IE4) Then
  TB_MARKBUTTON = (WM_USER + 6)
#End If ' IE4
  TB_ISBUTTONENABLED = (WM_USER + 9)
  TB_ISBUTTONCHECKED = (WM_USER + 10)
  TB_ISBUTTONPRESSED = (WM_USER + 11)
  TB_ISBUTTONHIDDEN = (WM_USER + 12)
  TB_ISBUTTONINDETERMINATE = (WM_USER + 13)
#If (WIN32_IE >= IE4) Then
  TB_ISBUTTONHIGHLIGHTED = (WM_USER + 14)
#End If ' IE4
  TB_SETSTATE = (WM_USER + 17)
  TB_GETSTATE = (WM_USER + 18)
  TB_ADDBITMAP = (WM_USER + 19)
'#If (WIN32_IE >= IE4) Then
  TB_ADDBUTTONSA = (WM_USER + 20)
  TB_INSERTBUTTONA = (WM_USER + 21)
'#Else
'  TB_ADDBUTTONS = (WM_USER + 20)
'  TB_INSERTBUTTON = (WM_USER + 21)
'#End If ' IE4
  
  TB_DELETEBUTTON = (WM_USER + 22)
  TB_GETBUTTON = (WM_USER + 23)
  TB_BUTTONCOUNT = (WM_USER + 24)
  TB_COMMANDTOINDEX = (WM_USER + 25)
  
  TB_SAVERESTOREA = (WM_USER + 26)
  TB_SAVERESTOREW = (WM_USER + 76)
  TB_CUSTOMIZE = (WM_USER + 27)
  TB_ADDSTRINGA = (WM_USER + 28)
  TB_ADDSTRINGW = (WM_USER + 77)
  TB_GETITEMRECT = (WM_USER + 29)
  TB_BUTTONSTRUCTSIZE = (WM_USER + 30)
  TB_SETBUTTONSIZE = (WM_USER + 31)
  TB_SETBITMAPSIZE = (WM_USER + 32)
  TB_AUTOSIZE = (WM_USER + 33)
  TB_GETTOOLTIPS = (WM_USER + 35)
  TB_SETTOOLTIPS = (WM_USER + 36)
  TB_SETPARENT = (WM_USER + 37)
  TB_SETROWS = (WM_USER + 39)
  TB_GETROWS = (WM_USER + 40)
  TB_GETBITMAPFLAGS = (WM_USER + 41)
  TB_SETCMDID = (WM_USER + 42)
  TB_CHANGEBITMAP = (WM_USER + 43)
  TB_GETBITMAP = (WM_USER + 44)
  TB_GETBUTTONTEXTA = (WM_USER + 45)
  TB_GETBUTTONTEXTW = (WM_USER + 75)
  TB_REPLACEBITMAP = (WM_USER + 46)
#If (WIN32_IE >= IE3) Then
  TB_SETINDENT = (WM_USER + 47)
  TB_SETIMAGELIST = (WM_USER + 48)
  TB_GETIMAGELIST = (WM_USER + 49)
  TB_LOADIMAGES = (WM_USER + 50)
  TB_GETRECT = (WM_USER + 51)               ' wParam is the Cmd instead of index
  TB_SETHOTIMAGELIST = (WM_USER + 52)
  TB_GETHOTIMAGELIST = (WM_USER + 53)
  TB_SETDISABLEDIMAGELIST = (WM_USER + 54)
  TB_GETDISABLEDIMAGELIST = (WM_USER + 55)
  TB_SETSTYLE = (WM_USER + 56)
  TB_GETSTYLE = (WM_USER + 57)
  TB_GETBUTTONSIZE = (WM_USER + 58)
  TB_SETBUTTONWIDTH = (WM_USER + 59)
  TB_SETMAXTEXTROWS = (WM_USER + 60)
  TB_GETTEXTROWS = (WM_USER + 61)
#End If ' (WIN32_IE >= IE3)
  
#If (UNICODE) Then
  TB_GETBUTTONTEXT = TB_GETBUTTONTEXTW
  TB_SAVERESTORE = TB_SAVERESTOREW
  TB_ADDSTRING = TB_ADDSTRINGW
#Else
  TB_GETBUTTONTEXT = TB_GETBUTTONTEXTA
  TB_SAVERESTORE = TB_SAVERESTOREA
  TB_ADDSTRING = TB_ADDSTRINGA
#End If
#If (WIN32_IE >= IE4) Then
  TB_GETOBJECT = (WM_USER + 62)              ' wParam == IID, lParam void **ppv
  TB_GETHOTITEM = (WM_USER + 71)
  TB_SETHOTITEM = (WM_USER + 72)             ' wParam == iHotItem
  TB_SETANCHORHIGHLIGHT = (WM_USER + 73)     ' wParam == TRUE/FALSE
  TB_GETANCHORHIGHLIGHT = (WM_USER + 74)
  TB_MAPACCELERATORA = (WM_USER + 78)        ' wParam == ch, lParam int * pidBtn
  
  TB_GETINSERTMARK = (WM_USER + 79)          ' lParam == TBINSERTMARK
  TB_SETINSERTMARK = (WM_USER + 80)          ' lParam == TBINSERTMARK
  TB_INSERTMARKHITTEST = (WM_USER + 81)      ' wParam == POINT lParam == TBINSERTMARK
  TB_MOVEBUTTON = (WM_USER + 82)
  TB_GETMAXSIZE = (WM_USER + 83)             ' lParam == SIZE
  TB_SETEXTENDEDSTYLE = (WM_USER + 84)       ' For TBSTYLE_EX_*
  TB_GETEXTENDEDSTYLE = (WM_USER + 85)       ' For TBSTYLE_EX_*
  TB_GETPADDING = (WM_USER + 86)
  TB_SETPADDING = (WM_USER + 87)
  TB_SETINSERTMARKCOLOR = (WM_USER + 88)
  TB_GETINSERTMARKCOLOR = (WM_USER + 89)
  
  TB_SETCOLORSCHEME = CCM_SETCOLORSCHEME       ' lParam is color scheme
  TB_GETCOLORSCHEME = CCM_GETCOLORSCHEME       ' fills in COLORSCHEME pointed to by lParam
  
  TB_SETUNICODEFORMAT = CCM_SETUNICODEFORMAT
  TB_GETUNICODEFORMAT = CCM_GETUNICODEFORMAT
  
  TB_MAPACCELERATORW = (WM_USER + 90)        ' wParam == ch, lParam int * pidBtn
#If (UNICODE) Then
  TB_MAPACCELERATOR = TB_MAPACCELERATORW
#Else
  TB_MAPACCELERATOR = TB_MAPACCELERATORA
#End If
#End If ' IE4
  
  ' BUTTONINFO APIs do NOT support the string pool.
  TB_GETBUTTONINFOW = (WM_USER + 63)
  TB_SETBUTTONINFOW = (WM_USER + 64)
  TB_GETBUTTONINFOA = (WM_USER + 65)
  TB_SETBUTTONINFOA = (WM_USER + 66)
#If (UNICODE) Then
  TB_GETBUTTONINFO = TB_GETBUTTONINFOW
  TB_SETBUTTONINFO = TB_SETBUTTONINFOW
#Else
  TB_GETBUTTONINFO = TB_GETBUTTONINFOA
  TB_SETBUTTONINFO = TB_SETBUTTONINFOA
#End If
  
  TB_INSERTBUTTONW = (WM_USER + 67)
  TB_ADDBUTTONSW = (WM_USER + 68)
  
  TB_HITTEST = (WM_USER + 69)
  
  ' New post Win95/NT4 for InsertButton and AddButton.  if iString member
  ' is a pointer to a string, it will be handled as a string like listview
  ' (although LPSTR_TEXTCALLBACK is not supported).
#If (UNICODE) Then
  TB_INSERTBUTTON = TB_INSERTBUTTONW
  TB_ADDBUTTONS = TB_ADDBUTTONSW
#Else
  TB_INSERTBUTTON = TB_INSERTBUTTONA
  TB_ADDBUTTONS = TB_ADDBUTTONSA
#End If
  
  TB_SETDRAWTEXTFLAGS = (WM_USER + 70)       ' wParam == mask lParam == bit values
  
#If (WIN32_IE >= IE5) Then
  TB_GETSTRINGW = (WM_USER + 91)
  TB_GETSTRINGA = (WM_USER + 92)
#If (UNICODE) Then
  TB_GETSTRING = TB_GETSTRINGW
#Else
  TB_GETSTRING = TB_GETSTRINGA
#End If
#End If ' (WIN32_IE >= IE5)
End Enum

Public Enum ToolBarNotifications
  TBN_LAST = &H720 ' toolbar
  TBN_FIRST = -700&
  
  TBN_GETBUTTONINFOA = (TBN_FIRST - 0)
  TBN_GETBUTTONINFOW = (TBN_FIRST - 20)
  TBN_GETBUTTONINFO = TBN_GETBUTTONINFOA
  TBN_BEGINDRAG = (TBN_FIRST - 1)
  TBN_ENDDRAG = (TBN_FIRST - 2)
  TBN_BEGINADJUST = (TBN_FIRST - 3)
  TBN_ENDADJUST = (TBN_FIRST - 4)
  TBN_RESET = (TBN_FIRST - 5)
  TBN_QUERYINSERT = (TBN_FIRST - 6)
  TBN_QUERYDELETE = (TBN_FIRST - 7)
  TBN_TOOLBARCHANGE = (TBN_FIRST - 8)
  TBN_CUSTHELP = (TBN_FIRST - 9)
#If (WIN32_IE >= IE3) Then
  TBN_DROPDOWN = (TBN_FIRST - 10)
#If (WIN32_IE >= IE4) Then
  TBN_GETOBJECT = (TBN_FIRST - 12)
  TBN_HOTITEMCHANGE = (TBN_FIRST - 13)
  TBN_DRAGOUT = (TBN_FIRST - 14) ' this is sent when the user clicks down on a button then drags off the button
  TBN_DELETINGBUTTON = (TBN_FIRST - 15) ' uses TBNOTIFY
  TBN_GETDISPINFOA = (TBN_FIRST - 16) ' This is sent when the  toolbar needs  some display information
  TBN_GETDISPINFOW = (TBN_FIRST - 17) ' This is sent when the  toolbar needs  some display information
  TBN_GETINFOTIPA = (TBN_FIRST - 18)
  TBN_GETINFOTIPW = (TBN_FIRST - 19)
  TBN_GETDISPINFO = TBN_GETDISPINFOA
  TBN_GETINFOTIP = TBN_GETINFOTIPA
#If (WIN32_IE >= IE5) Then
  TBN_RESTORE = (TBN_FIRST - 21)
  TBN_SAVE = (TBN_FIRST - 22)
  TBN_INITCUSTOMIZE = (TBN_FIRST - 23)
#End If ' (IE5)
#End If ' (IE4)
#End If ' (IE4)
End Enum

Public Type TBBUTTON
  iBitmap As Long
  idCommand As Long
  fsState As Byte
  fsStyle As Byte
  bReserved1 As Byte
  bReserved2 As Byte
#If Win64 Then
  bReserved3 As Byte
  bReserved4 As Byte
  bReserved5 As Byte
  bReserved6 As Byte
#End If
  dwData As Long
  iString As Long
End Type

Public Type TBSAVEPARAMS
  HKEY As Long
  pszSubKey As Long
  pszValueName As Long
End Type

#If (WIN32_IE >= IE3) Then
  Public Type NMTOOLBAR
    hdr As NMHDR
    iItem As Long
    TBBUTTON As TBBUTTON
    cchText As Long
    pszText As Long
  End Type
#End If

#If (WIN32_IE >= IE4) Then
  Public Const TBNF_DI_SETITEM = &H10000000 ' TbrRequestType enum
  
  Public Type TBINSERTMARK
    iButton As Long
    dwFlags As Long
  End Type
  
  Public Const TBIMHT_AFTER = &H1 ' TRUE = insert After iButton, otherwise before
  Public Const TBIMHT_BACKGROUND = &H2 ' TRUE iff missed buttons completely
  
  Public Type NMTBCUSTOMDRAW
    nmcd As NMCUSTOMDRAW
    hbrMonoDither As Long
    hbrLines As Long               ' For drawing lines on buttons
    hpenLines As Long              ' For drawing lines on buttons
    
    clrText As Long                ' Color of text
    clrMark As Long                ' Color of text bk when marked. (only if TBSTATE_MARKED)
    clrTextHighlight As Long       ' Color of text when highlighted
    clrBtnFacet As Long            ' Background of the button
    clrBtnHighlightt As Long       ' 3D highlight
    clrHighlightHotTrackt As Long  ' In conjunction with fHighlightHotTrack will cause button to highlight like a menu
    rcText As RECT                 ' Rect for text
    
    nStringBkMode As Long
    nHLStringBkMode As Long
  End Type
  
  Public Const CLR_LIGHT_BORDER = SystemColorConstants.vb3DHighlight
  Public Const CLR_SHADOW_BORDER = SystemColorConstants.vb3DShadow
  
  Public Type NMTBHOTITEM
    hdr As NMHDR
    idOld As Long
    idNew As Long
    dwFlags As Long
  End Type
  
  Public Type NMTBGETINFOTIP
    hdr As NMHDR
    pszText As Long
    cchTextMax As Long
    iItem As Long
    lParam As Long
  End Type
  
  Public Type NMTBDISPINFO
    hdr As NMHDR
    dwMask As Long     ' [in] Specifies the values requested .[out] Client ask the data to be set for future use
    idCommand As Long  ' [in] id of button we're requesting info for
    lParam As Long     ' [in] lParam of button
    iImage As Long     ' [out] image index
    pszText As String  ' [out] new text for item
    cchText As Long    ' [in] size of buffer pointed to by pszText
  End Type
#End If

#If (WIN32_IE >= IE5) Then
  Public Const TBNRF_HIDEHELP = &H1
  Public Const TBNRF_ENDCUSTOMIZE = &H2
  
  Public Type NMTBSAVE
    hdr As NMHDR
    pData As Long
    pCurrent As Long
    cbData As Long
    iItem As Long
    cButtons As Long
    TBBUTTON As TBBUTTON
  End Type
  
  Public Type NMTBRESTORE
    hdr As NMHDR
    pData As Long
    pCurrent As Long
    cbData As Long
    iItem As Long
    cButtons As Long
    cbBytesPerRecord As Long
    TBBUTTON As TBBUTTON
  End Type
#End If 'IE5

' Button bitmap
Public Const HINST_COMMCTRL = (-1)

Public Type TBADDBITMAP
  hInst As Long
  nID As Long
End Type

Public Type TBREPLACEBITMAP
  hInstOld As Long ' Use hInst or
  nIDOld As Long   ' use nID
  hInstNew As Long
  nIDNew As Long
  nButtons As Integer
End Type

Public Enum CreateMappedBitmapFlags
  CMB_MASKED = &H2
End Enum

Public Type COLORMAP
  From As Long
  To As Long
End Type

Public Enum ToolBarStyles
  TBSTYLE_TOOLTIPS = &H100&
  TBSTYLE_WRAPABLE = &H200&
  TBSTYLE_ALTDRAG = &H400&
#If (WIN32_IE >= IE3) Then
  TBSTYLE_FLAT = &H800&
  TBSTYLE_LIST = &H1000&
  TBSTYLE_CUSTOMERASE = &H2000
#End If 'IE3
#If (WIN32_IE >= IE4) Then
  TBSTYLE_REGISTERDROP = &H4000
  TBSTYLE_TRANSPARENT = &H8000&
#End If
End Enum

#If (WIN32_IE >= IE4) Then
  Public Enum ToolBarExStyles
    TBSTYLE_EX_DRAWDDARROWS = &H1
#If (WIN32_IE >= IE501) Then
    TBSTYLE_EX_MIXEDBUTTONS = &H8
    TBSTYLE_EX_HIDECLIPPEDBUTTONS = &H10  ' don't show partially obscured buttons
#End If
  End Enum
  
  Public Enum ToolbarCustomRedrawReturnFlags
    TBCDRF_NOEDGES = &H10000              ' Don't draw button edges
    TBCDRF_HILITEHOTTRACK = &H20000       ' Use color of the button bk when hottracked
    TBCDRF_NOOFFSET = &H40000             ' Don't offset button if pressed
    TBCDRF_NOMARK = &H80000               ' Don't draw default highlight of image/text for TBSTATE_MARKED
    TBCDRF_NOETCHEDEFFECT = &H100000      ' Don't draw etched effect for disabled items
#If (WIN32_IE >= IE500) Then
    TBCDRF_BLENDICON = &H200000           ' Use ILD_BLEND50 on the icon image
#End If
  End Enum
  
  Public Enum ToolBarButtonInfoMasks
    TBIF_IMAGE = &H1
    TBIF_TEXT = &H2
    TBIF_STATE = &H4
    TBIF_STYLE = &H8
    TBIF_LPARAM = &H10
    TBIF_COMMAND = &H20
    TBIF_SIZE = &H40
#If (WIN32_IE >= IE5) Then
    TBIF_BYINDEX = &H80000000 ' IE5!!
#End If
  End Enum
  
  Public Type TBBUTTONINFO
    cbSize As Long
    dwMask As Long 'TBIF_BYINDEX|TBIF_COMMAND|TBIF_IMAGE|TBIF_LPARAM|TBIF_SIZE|TBIF_STATE|TBIF_STYLE|TBIF_TEXT
    idCommand As Long
    iImage As Long
    fsState As Byte
    fsStyle As Byte
    cx As Integer
    lParam As Long
    pszText As Long ' lpString
    cchText As Long
  End Type
#End If


'------------------------------------------------------------------------
' MenuBar modified toolbar buttons

#If (WIN32_IE >= IE3) Then
  Public Const MBSTATE_ALL = mbrStatePressed Or mbrStateEnabled Or mbrStateHidden Or mbrStateWrappedAfter Or mbrStateEllipses
#Else
  Public Const MBSTATE_ALL = mbrStatePressed Or mbrStateEnabled Or mbrStateHidden Or mbrStateWrappedAfter
#End If

Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Public Declare Function MenuItemFromPoint Lib "user32" (ByVal hWnd As Long, ByVal hMenu As Long, ByVal ptScreen As POINTAPI) As Long

Public Const MBR_PROP_ISMENUBAR = "MenuBar_IS"
Private CurID As Long


'------------------------------------------------------------------------
' Get Unique ID:

Public Function ToolBar_GetUniqueID(ByVal hWnd As OLE_HANDLE) As Integer
  If CurID = 0 Then CurID = BUTTON_IDGEN_BASE
  Do
    CurID = CurID + 1
    If CurID > BUTTON_IDGEN_MAX Then Error 6
  Loop While SendMessage(hWnd, TB_COMMANDTOINDEX, CurID, ByVal 0) <> -1
  ToolBar_GetUniqueID = CInt(CurID)
End Function



'------------------------------------------------------------------------
' Helper functions

Public Function ToolBarButton_Rect(ByVal hWnd As OLE_HANDLE, ByVal Index As Long) As RECT
  Call SendMessage(hWnd, TB_GETITEMRECT, Index - 1, ToolBarButton_Rect)
  Call MapWindowPoints(hWnd, GetParent(hWnd), ToolBarButton_Rect, 2)
End Function

'------------------------------------------------------------------------

Public Function ToolBarButton_Info(ByVal hWnd As OLE_HANDLE, ByVal Index As Long) As TBBUTTON
  If SendMessage(hWnd, TB_GETBUTTON, Index, ToolBarButton_Info) = 0 Then Err.Raise 49, , "Failed to get button info!"
End Function

Public Function ToolBar_GetItem(ByVal hWnd As OLE_HANDLE, ByVal Index As Long) As Object
  Dim ButtonInfo As TBBUTTON
  If SendMessage(hWnd, TB_GETBUTTON, Index, ButtonInfo) = 0 Then Err.Raise 49, , "Failed to get button info!"
  Set ToolBar_GetItem = GetObjFromPtr(-ButtonInfo.dwData)
  If ToolBar_GetItem Is Nothing Then
    Debug.Print "  Adding new button: - ";
    Dim TB_Buttons As Collection
    Dim NewButton As ToolBarButton ' Make new button
    Set NewButton = New ToolBarButton
    ButtonInfo.dwData = -ObjPtr(NewButton)
    Call NewButton.ToolBarButton_Create(hWnd, vbNullString, ButtonInfo.dwData, vbNullString, vbNullString, Nothing)
    Set TB_Buttons = GetObjFromPtr(-GetProp(hWnd, TBR_PROP_BUTTONSCOL))
    If Not TB_Buttons Is Nothing Then
      ' Can we also store the button?
      If SendMessage(hWnd, TB_DELETEBUTTON, Index, ByVal 0&) <> 0 Then
        If SendMessage(hWnd, TB_INSERTBUTTON, Index, ButtonInfo) <> 0 Then
          Call TB_Buttons.Add(NewButton, "ButtonCls=" & -ButtonInfo.dwData)
        End If
      End If
    End If
    Set ToolBar_GetItem = NewButton
  End If
End Function

Public Function ToolBar_GetItemFromID(ByVal hWnd As OLE_HANDLE, ByVal CommandID As Long) As Object
  Set ToolBar_GetItemFromID = ToolBar_GetItem(hWnd, SendMessage(hWnd, TB_COMMANDTOINDEX, CommandID, ByVal 0))
End Function

Public Sub ToolBar_StyleMod(ByVal hWnd As OLE_HANDLE, ByVal WinStyle As ToolBarStyles, ByVal Add As Boolean)
  If Add Then
    Call SendMessage(hWnd, TB_SETSTYLE, 0, ByVal SendMessage(hWnd, TB_GETSTYLE, 0, ByVal 0) Or WinStyle)
  Else
    Call SendMessage(hWnd, TB_SETSTYLE, 0, ByVal SendMessage(hWnd, TB_GETSTYLE, 0, ByVal 0) And Not WinStyle)
  End If
End Sub

#If (WIN32_IE >= IE4) Then
  Public Sub ToolBar_ExStyleMod(ByVal hWnd As OLE_HANDLE, ByVal WinExStyle As ToolBarExStyles, ByVal Add As Boolean)
    If Add Then
      Call SendMessage(hWnd, TB_SETEXTENDEDSTYLE, 0, ByVal SendMessage(hWnd, TB_GETEXTENDEDSTYLE, 0, ByVal 0) Or WinExStyle)
    Else
      Call SendMessage(hWnd, TB_SETEXTENDEDSTYLE, 0, ByVal SendMessage(hWnd, TB_GETEXTENDEDSTYLE, 0, ByVal 0) And Not WinExStyle)
    End If
  End Sub
#End If

Public Property Get ToolBarButton_State(ByVal hWnd As OLE_HANDLE, ByVal ID As Long, ByVal State As TbrButtonStates) As Boolean
  ToolBarButton_State = (SendMessage(hWnd, TB_GETSTATE, ID, ByVal 0&) And State)
End Property

Public Property Let ToolBarButton_State(ByVal hWnd As OLE_HANDLE, ByVal ID As Long, ByVal State As TbrButtonStates, ByVal AddState As Boolean)
  Dim NewState As TbrButtonStates
  NewState = SendMessage(hWnd, TB_GETSTATE, ID, ByVal 0&)
  If NewState = -1 Then Error 383
  If AddState Then
    NewState = NewState Or State
  Else
    NewState = NewState And Not State
  End If
  If SendMessage(hWnd, TB_SETSTATE, ID, ByVal NewState) = 0 Then Error 394
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get ToolBarButton_InfoEx(ByVal hWnd As OLE_HANDLE, ByVal ID As Long, ByVal Mask As ToolBarButtonInfoMasks) As TBBUTTONINFO
    ToolBarButton_InfoEx.cbSize = LenB(ToolBarButton_InfoEx)
    ToolBarButton_InfoEx.dwMask = Mask
    If SendMessage(hWnd, TB_GETBUTTONINFO, ID, ToolBarButton_InfoEx) = 0 Then Err.Raise 383
  End Property

  Public Property Let ToolBarButton_InfoEx(ByVal hWnd As OLE_HANDLE, ByVal ID As Long, ByVal Mask As ToolBarButtonInfoMasks, ByRef NewValue As TBBUTTONINFO)
    NewValue.cbSize = LenB(NewValue)
    NewValue.dwMask = Mask
    If SendMessage(hWnd, TB_SETBUTTONINFO, ID, NewValue) = 0 Then Error 394
  End Property
#End If

Public Sub ToolBar_Resize(ByVal hWnd As OLE_HANDLE)
  Dim ParentArea As RECT
  Dim MenuArea As RECT
  Dim MenuBarArea As RECT
  Dim Point As POINTAPI
  Dim Count As Long
  Dim I As Long
  
  Dim BarWidth As Long
  Dim BarHeight As Long
  
  Count = SendMessage(hWnd, TB_BUTTONCOUNT, 0, ByVal 0)
  
  If (Count > 0) Then
    ' Get the total length:
    For I = 0 To Count - 1
      If (ToolBarButton_Info(hWnd, I).fsState And tbrStateHidden) = 0 Then
        Call SendMessage(hWnd, TB_GETITEMRECT, I, MenuArea)
        BarWidth = MenuArea.Right - MenuArea.Left + BarWidth
        BarHeight = MenuArea.Bottom
      End If
    Next
    
    ' Get rectangle for menubar.  Unfortunately the rebar doesn't
    ' seem to like ClientToScreen and gives the wrong answer!
    ' So do it manually:
    Call GetWindowRect(hWnd, MenuBarArea)
    Call GetWindowRect(GetParent(hWnd), ParentArea)
    
    Point.X = MenuBarArea.Left - ParentArea.Left - 2
    Point.Y = MenuBarArea.Top - ParentArea.Top - 2
    
    Call SetWindowPos(hWnd, 0, Point.X, Point.Y, BarWidth, BarHeight, SWP_FRAMECHANGED Or SWP_NOMOVE Or SWP_NOOWNERZORDER)
  End If
End Sub

Public Sub ToolBar_Update(ByVal hWnd As Long, ByVal UserMode As Boolean)
  If UserMode Then
    Call SetWindowPos(hWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_FRAMECHANGED))
  Else
    If IsWindowVisible(hWnd) <> 0 Then
      Call SetWindowPos(hWnd, 0, 0, 0, 0, 0, SWP_HIDEWINDOW Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE)
      Call SetWindowPos(hWnd, 0, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE)
    End If
  End If
End Sub

