VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ToolBarButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Embeds an single button in the toolbar control."
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Option Explicit

'==================================================================
'
' Toolbar Button Class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================



'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?


'-----------------------------------------------------------
' Current Properties

Private CurhWnd As Long
Private CurAvailable As Boolean
Private CurTooltip As String
Private CurDescription As String
Private CollectionKey As String
Private CurSubMenu As MenuContainer
Private CurObjPtr As Long ' For MenuBar
Private CurLastIndex As Long


'-----------------------------------------------------------
' Public Enums

Public Enum TbrButtonStyles
  tbrStyleButton = &H0                                  ' TBSTYLE_BUTTON | BTNS_BUTTON
  tbrStyleSeparator = &H1                               ' TBSTYLE_SEP | BTNS_SEP
  tbrStyleCheck = &H2                                   ' TBSTYLE_CHECK | BTNS_CHECK
  tbrStyleGroup = &H4                                   ' TBSTYLE_GROUP | BTNS_GROUP
  tbrStyleCheckGroup = (tbrStyleCheck Or tbrStyleGroup) ' TBSTYLE_CHECKGROUP | BTNS_CHECKGROUP
#If (WIN32_IE >= IE3) Then
  tbrStyleDropDown = &H8                                ' TBSTYLE_DROPDOWN | BTNS_DROPDOWN
  #End If 'IE3
#If (WIN32_IE >= IE4) Then
  tbrStyleAutoSize = &H10                               ' TBSTYLE_AUTOSIZE | BTNS_AUTOSIZE
  tbrStyleNoPrefix = &H20                               ' TBSTYLE_NOPREFIX | BTNS_NOPREFIX
#End If
#If (WIN32_IE >= IE5) Then
  tbrStyleWholeDropDown = &H80                          ' BTNS_WHOLEDROPDOWN
#End If
#If (WIN32_IE >= IE501) Then
  tbrStyleShowText = &H40                               ' BTNS_SHOWTEXT
#End If
End Enum

Public Enum TbrButtonStates
  tbrStateChecked = &H1           ' TBSTATE_CHECKED
  tbrStatePressed = &H2           ' TBSTATE_PRESSED
  tbrStateEnabled = &H4           ' TBSTATE_ENABLED
  tbrStateHidden = &H8            ' TBSTATE_HIDDEN
  tbrStateIndeterminate = &H10    ' TBSTATE_INDETERMINATE
  tbrStateWrappedAfter = &H20     ' TBSTATE_WRAP
#If (WIN32_IE >= IE3) Then
  tbrStateEllipses = &H40         ' TBSTATE_ELLIPSES
#End If 'IE3
#If (WIN32_IE >= IE4) Then
  tbrStateMarked = &H80           ' TBSTATE_MARKED
#End If
End Enum

Public Enum TbrButtonBitmapSpecials
  tbrButtonBitmapCallback = -1  ' I_IMAGECALLBACK
  tbrButtonBitmapNone = -2      ' I_IMAGENONE
End Enum


'===========================================================


'-----------------------------------------------------------
' Class Interface

Private Sub Class_Initialize()
  CollectionKey = "0"
End Sub

Friend Sub ToolBarButton_Create(hWnd As Long, Key As String, ObjPtr As Long, Description As String, ToolTipText As String, SubMenu As MenuContainer)
  If CollectionKey <> "0" Then Error 383
  CurhWnd = hWnd
  CollectionKey = Key
  CurDescription = Description
  CurAvailable = True
  CurTooltip = ToolTipText
  CurObjPtr = ObjPtr
  Set CurSubMenu = SubMenu
End Sub

'-----------------------------------------------------------
' Index/Key properties

Public Property Get Key() As String
Attribute Key.VB_Description = "Returns a string value that identifies the button in the button collection."
  Key = CollectionKey
End Property

Public Property Get Index() As Long
Attribute Index.VB_Description = "Returns/Sets the index if the button in the button collection."
Attribute Index.VB_MemberFlags = "40"
  Dim I As Long
  Dim ButtonInfo As TBBUTTON
  
  If CurLastIndex Then
    If SendMessage(CurhWnd, TB_GETBUTTON, CurLastIndex - 1, ButtonInfo) <> 0 Then
      If ButtonInfo.dwData = CurObjPtr Then
        Index = CurLastIndex
        Exit Property
      End If
    End If
  End If
  
  For I = 0 To SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) - 1
    ButtonInfo = ToolBarButton_Info(CurhWnd, I)
    If ButtonInfo.dwData = CurObjPtr Then
      Index = I + 1
      CurLastIndex = Index
      Exit Property
    End If
  Next
  
  CurLastIndex = 0
  Error 5
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Let Index(NewValue As Long)
    If SendMessage(CurhWnd, TB_MOVEBUTTON, Me.Index - 1, NewValue - 1) = 0 Then Error 380
  End Property
#End If

'-----------------------------------------------------------
' Button properties/states

Public Sub Click()
Attribute Click.VB_Description = "Generates an click event."
  Call SendMessage(CurhWnd, WM_COMMAND, Me.ID, ByVal CurhWnd)
End Sub

Public Sub DropDown()
Attribute DropDown.VB_Description = "This method generates a drop down message for this button."
  Dim NMTBR As NMTOOLBAR
  NMTBR.iItem = ToolBarButton_Info(CurhWnd, Me.Index - 1).idCommand
  NMTBR.hdr.code = TBN_DROPDOWN
  NMTBR.hdr.hWndFrom = CurhWnd
  NMTBR.hdr.IdFrom = -2 ' Some misc id.
  Call SendMessage(CurhWnd, WM_NOTIFY, 0, NMTBR)
End Sub

Public Property Get ID() As Integer
Attribute ID.VB_Description = "Returns the internal ID used."
  ID = CLng(ToolBarButton_Info(CurhWnd, Me.Index - 1).idCommand)
End Property

Public Property Let ID(NewValue As Integer)
  If SendMessage(CurhWnd, TB_SETCMDID, Me.Index - 1, ByVal CLng(NewValue)) = 0 Then Error 380
End Property

Public Property Get ImageIndex() As Long
Attribute ImageIndex.VB_Description = "Returns the button bitmap image index."
Attribute ImageIndex.VB_ProcData.VB_Invoke_Property = ";Misc"
  ImageIndex = SendMessage(CurhWnd, TB_GETBITMAP, Me.ID, ByVal 0)
  If ImageIndex >= 0 Then ImageIndex = ImageIndex + 1
End Property

Public Property Let ImageIndex(ByVal NewValue As Long)
  If NewValue > 0 Then NewValue = NewValue - 1
  If SendMessage(CurhWnd, TB_CHANGEBITMAP, Me.ID, ByVal NewValue) = 0 Then Error 380
End Property

Public Property Get SubMenu() As MenuContainer
Attribute SubMenu.VB_Description = "Returns a submenu if a submenu is attached to the button."
  Set SubMenu = CurSubMenu
End Property

Public Property Set SubMenu(NewValue As MenuContainer)
  If Not NewValue Is Nothing Then
    If Not TypeOf NewValue Is MenuContainer Then Error 380
    If IsMenu(NewValue.hMenu) = 0 Then Error 380
  End If
  Set CurSubMenu = NewValue
End Property

Public Property Get Style() As TbrButtonStyles
Attribute Style.VB_Description = "Returns/Sets the style flags for the button."
Attribute Style.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Style = ToolBarButton_Info(CurhWnd, Me.Index - 1).fsStyle
End Property

Public Property Get State() As TbrButtonStates
Attribute State.VB_Description = "Returns the state of the button."
  State = SendMessage(CurhWnd, TB_GETSTATE, Me.ID, ByVal 0&)
  If State = -1 Then Error 5
End Property

Public Property Let State(NewValue As TbrButtonStates)
  If SendMessage(CurhWnd, TB_SETSTATE, ID, ByVal NewValue) = 0 Then Error 5
End Property

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns the text drawn on the button."
Attribute Caption.VB_ProcData.VB_Invoke_Property = ";Misc"
Attribute Caption.VB_UserMemId = 0
Attribute Caption.VB_MemberFlags = "200"
  Dim Buffer As String
  Dim TextLen As Long
  Buffer = String(256, 0)
  TextLen = SendMessage(CurhWnd, TB_GETBUTTONTEXTA, Me.ID, ByVal Buffer)
  If TextLen = -1 Then
    Caption = vbNullString ' Function failed, bad calling or no caption assigned
  Else
    Caption = Mid(Buffer, 1, TextLen)
  End If
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/Sets the enabled flag for the button."
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Enabled = ToolBarButton_State(CurhWnd, Me.ID, tbrStateEnabled)
End Property

Public Property Let Enabled(NewValue As Boolean)
  ToolBarButton_State(CurhWnd, Me.ID, tbrStateEnabled) = NewValue
End Property

Public Property Get Visible() As Boolean
Attribute Visible.VB_Description = "Returns/Sets the visible flag for the button."
  Visible = Not ToolBarButton_State(CurhWnd, Me.ID, tbrStateHidden)
End Property

Public Property Let Visible(NewValue As Boolean)
  ToolBarButton_State(CurhWnd, Me.ID, tbrStateHidden) = Not NewValue
End Property

Public Property Get Checked() As Boolean
Attribute Checked.VB_Description = "Returns/Sets the checked flag for the button."
Attribute Checked.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Checked = Not ToolBarButton_State(CurhWnd, Me.ID, tbrStateChecked)
End Property

Public Property Let Checked(NewValue As Boolean)
  ToolBarButton_State(CurhWnd, Me.ID, tbrStateChecked) = Not NewValue
End Property

Public Property Get Pressed() As Boolean
Attribute Pressed.VB_Description = "Returns/Sets the pressed flag for the button."
  Pressed = ToolBarButton_State(CurhWnd, Me.ID, tbrStatePressed)
End Property

Public Property Let Pressed(NewValue As Boolean)
  ToolBarButton_State(CurhWnd, Me.ID, tbrStatePressed) = NewValue
  Call UpdateWindow(CurhWnd)
End Property

Public Property Get WrapButtons() As Boolean
Attribute WrapButtons.VB_Description = "Returns/Sets the wrap next buttons flag for the button."
Attribute WrapButtons.VB_ProcData.VB_Invoke_Property = ";Appearance"
  WrapButtons = ToolBarButton_State(CurhWnd, Me.ID, tbrStateWrappedAfter)
End Property

Public Property Let WrapButtons(NewValue As Boolean)
  ToolBarButton_State(CurhWnd, Me.ID, tbrStateWrappedAfter) = NewValue
End Property

Public Property Get Indeterminate() As Boolean
Attribute Indeterminate.VB_Description = "Returns/Sets the indeterminate flag for the button."
Attribute Indeterminate.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Indeterminate = ToolBarButton_State(CurhWnd, Me.ID, tbrStateIndeterminate)
End Property

Public Property Let Indeterminate(NewValue As Boolean)
  ToolBarButton_State(CurhWnd, Me.ID, tbrStateIndeterminate) = NewValue
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get Marked() As Boolean
    Marked = ToolBarButton_State(CurhWnd, Me.ID, tbrStateMarked)
  End Property
  
  Public Property Let Marked(NewValue As Boolean)
    ToolBarButton_State(CurhWnd, Me.ID, tbrStateMarked) = NewValue
  End Property
#End If

Public Property Get Ellipses() As Boolean
Attribute Ellipses.VB_Description = "Returns/Sets the text-ellipses flag for the button."
Attribute Ellipses.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Ellipses = ToolBarButton_State(CurhWnd, Me.ID, tbrStateEllipses)
End Property

Public Property Let Ellipses(NewValue As Boolean)
  ToolBarButton_State(CurhWnd, Me.ID, tbrStateEllipses) = NewValue
End Property

Public Property Get Left() As Long
Attribute Left.VB_Description = "Returns the client x position of the button."
  Left = ToolBarButton_Rect(CurhWnd, Me.Index).Left
End Property

Public Property Get Top() As Long
Attribute Top.VB_Description = "Returns the client y position of the button."
  Top = ToolBarButton_Rect(CurhWnd, Me.Index).Top
End Property

Public Property Get Width() As Long
Attribute Width.VB_Description = "Returns the width of the button."
  Dim Index As Long
  Index = Me.Index
  Width = ToolBarButton_Rect(CurhWnd, Index).Right - ToolBarButton_Rect(CurhWnd, Index).Left
End Property

Public Property Get Height() As Long
Attribute Height.VB_Description = "Returns the height of the button."
  Dim Index As Long
  Index = Me.Index
  Height = ToolBarButton_Rect(CurhWnd, Index).Bottom - ToolBarButton_Rect(CurhWnd, Index).Top
End Property

Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/Sets the tooltip text for the button."
Attribute ToolTipText.VB_ProcData.VB_Invoke_Property = ";Text"
  ToolTipText = CurTooltip
End Property

Public Property Let ToolTipText(NewValue As String)
  If Me.Style And tbrStyleSeparator Then Error 383
  CurTooltip = NewValue
End Property

Public Property Get Available() As Boolean
Attribute Available.VB_Description = "False if the toolbar button is removed by the customize dialog box."
  Available = CurAvailable
End Property

Friend Sub ToolBarButton_Available(NewValue As Boolean)
  CurAvailable = NewValue
End Sub

Public Property Get Description() As String
Attribute Description.VB_Description = "Stores an description for the button, which can be used in a tooltip or statusbar."
  Description = CurDescription
End Property

Public Property Let Description(NewValue As String)
  CurDescription = NewValue
End Property

'------------------------------------------------------------------------
' Get caption-Accelerator algorithm

Public Property Get Accelerator() As String
Attribute Accelerator.VB_Description = "Returns the keyboard accelerator key for the button."
  Dim Caption As String
  Dim I As Long
  Caption = Me.Caption
  For I = 1 To Len(Caption)
    If StrComp(Mid(Caption, I, 1), "&") = 0 And StrComp(Mid(Caption, I, 2), "&&") <> 0 Then
      Accelerator = Mid(Caption, I + 1, 1)
      Exit For
    End If
  Next
End Property


'===========================================================

