VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ToolBarButtons"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Contains all the buttons loaded in the toolbar control."
Attribute VB_Ext_KEY = "Collection" ,"UserDefinedCollection"
Attribute VB_Ext_KEY = "Member0" ,"ToolBarButton"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Option Explicit

'==================================================================
'
' Toolbar Button Collection Class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================


'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?


'-----------------------------------------------------------
' Current Properties

Private TB_Buttons As Collection ' Storage for button-classes so we always have one counted object reference (Means: Class can't terminate)
Private CurhWnd As Long
Private ButtonCaptionsNum As Long
Private ButtonCaptions() As String
Private ButtonCaptionsIDs() As Long
Private CurLastButton As ToolBarButton


'===========================================================

Friend Sub Class_InitProps(ByVal hWnd As OLE_HANDLE)
  CurhWnd = hWnd
  Set TB_Buttons = New Collection
End Sub

Friend Function Class_SaveCollection() As Collection
  Set Class_SaveCollection = TB_Buttons
End Function



'-----------------------------------------------------------
' Add/Remove/Count/Item

Public Function Add(Optional Index As Long, Optional Key As String, Optional Caption As String, Optional Style As TbrButtonStyles = tbrStyleButton, Optional State As TbrButtonStates = tbrStateEnabled, Optional Image As Long, Optional ToolTipText As String, Optional Description As String, Optional SubMenu As MenuContainer) As ToolBarButton
Attribute Add.VB_Description = "Adds a button to the toolbar."
  Dim NewButton As TBBUTTON
  Dim NewButtonCls As ToolBarButton
  Dim ID As Long
  
  If Style And tbrStyleSeparator Then
    If Caption <> "" Then Error 5
    If ToolTipText <> "" Then Error 5
    If Not SubMenu Is Nothing Then Error 5
    Caption = vbNullString
    ToolTipText = vbNullString
  ElseIf Not SubMenu Is Nothing Then
    If Not TypeOf SubMenu Is MenuContainer Then Error 5
    If IsMenu(SubMenu.hMenu) = 0 Then Error 5
  End If
  
  If Len(Key) Then
    On Error Resume Next
      Set NewButtonCls = Me.Item(Key)
    On Error GoTo 0
    If Not NewButtonCls Is Nothing Then Error 457
  End If
  
  ' Add button by api
  Set NewButtonCls = New ToolBarButton
  With NewButton
    .iBitmap = IIf(Image > 0, Image - 1, Image)
    .fsState = State
    .fsStyle = Style
    .dwData = -ObjPtr(NewButtonCls)
    If Len(Caption) > 0 Then
      .iString = ToolBarButton_AddString(Caption)
    Else
      .iString = -1 ' Properly the most invalid value you can pass through.
    End If
    If (Style And tbrStyleSeparator) = 0 Then .idCommand = ToolBar_GetUniqueID(CurhWnd) ' for WM_COMMAND and TT_NEEDTEXT
  End With
  If Index > 0 Then
    If Index > (SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) + 1) Then Error 5
    If SendMessage(CurhWnd, TB_INSERTBUTTON, Index - 1, NewButton) = 0 Then Error 5
  Else
    If SendMessage(CurhWnd, TB_ADDBUTTONS, 1, NewButton) = 0 Then Error 5
  End If
  
  ' Add button by vb
  Call NewButtonCls.ToolBarButton_Create(CurhWnd, Key, NewButton.dwData, Description, ToolTipText, SubMenu)
  Call TB_Buttons.Add(NewButtonCls, "ButtonCls=" & -NewButton.dwData)
  
  ' Resize toolbar
  Call ToolBar_Resize(CurhWnd)
'  Dim AreaBtn As RECT
'  Dim AreaTbr As RECT
'  Call SendMessage(CurhWnd, TB_GETITEMRECT, SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, Byval 0) - 1, AreaBtn)
'  Call GetWindowRect(CurhWnd, AreaTbr)
'  Call MoveWindow(CurhWnd, AreaTbr.Left, AreaTbr.Top, AreaBtn.Right - AreaBtn.Left, AreaBtn.Bottom - AreaBtn.Top, 1)
  Set Add = NewButtonCls
End Function

Public Property Get Count() As Long
Attribute Count.VB_Description = "Returns the number of buttons in the toolbar."
  Count = SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0)
End Property

Public Sub Remove(Index As Variant)
Attribute Remove.VB_Description = "Removes a button from the toolbar."
  Dim Button As ToolBarButton
  Set Button = Me.Item(Index)
  If SendMessage(CurhWnd, TB_DELETEBUTTON, Button.Index - 1, ByVal 0&) = 0 Then Error 5
  On Error Resume Next ' The button could already been removed at TBN_DELETINGBUTTON event
   Call TB_Buttons.Remove("ButtonCls=" & ObjPtr(Button))
  On Error GoTo 0
  Set Button = Nothing
End Sub

Public Property Get Item(Index As Variant) As ToolBarButton
Attribute Item.VB_Description = "Returns a button object."
Attribute Item.VB_UserMemId = 0
Attribute Item.VB_MemberFlags = "200"
  Dim Items As Long
  Items = SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0)
  
  If CStr(Val(Index)) = CStr(Index) Then ' Number?
    If Index > Items Or Index < 1 Then Error 5
    Set Item = ToolBar_GetItem(CurhWnd, Index - 1)
    Exit Property
  Else
    Dim I As Long
    Dim Ptr As Long
    Dim Button As ToolBarButton
    
    If Not CurLastButton Is Nothing Then
      If CurLastButton.Key = Index Then
        Set Item = Button
        Exit Property
      End If
    End If
    
    For I = 0 To Items - 1
      Set Button = ToolBar_GetItem(CurhWnd, I)
      If Not Button Is Nothing Then
        If Button.Key = Index Then
          Set CurLastButton = Button
          Set Item = Button
          Exit Property
        End If
      Else
        Debug.Print "ToolBar: Invalid button reference encountered (Button " & I + 1 & ")"
      End If
    Next
  End If
  
  Set CurLastButton = Nothing
  Error 5
End Property


'===========================================================


'-----------------------------------------------------------
' Utils

Friend Function ToolBarButton_AddString(ByVal Caption As String) As Long
  Dim ID As Long
  Dim I As Long
  Dim CharArray() As Byte
  Dim sAccel As String
  
  ' Check if we already have the string - if we do, then use that
  ID = -1
  For I = 1 To ButtonCaptionsNum
    If (ButtonCaptions(I) = Caption) Then
      ID = ButtonCaptionsIDs(I)
      Exit For
    End If
  Next I
  
  If (ID = -1) Then
    ' Add the string, it was not loaded jet to the toolbar string pool
    CharArray = StrConv(Caption, vbFromUnicode)
    I = UBound(CharArray) + 2
    ReDim Preserve CharArray(0 To I) As Byte
    CharArray(I - 1) = 0
    CharArray(I) = 0
    ID = SendMessage(CurhWnd, TB_ADDSTRING, 0, CharArray(0))
    
    ' Save the button to a locale string pool, we can't read the toolbar string pool!?
    ButtonCaptionsNum = ButtonCaptionsNum + 1
    ReDim Preserve ButtonCaptions(1 To ButtonCaptionsNum) As String
    ReDim Preserve ButtonCaptionsIDs(1 To ButtonCaptionsNum) As Long
    ButtonCaptions(ButtonCaptionsNum) = Caption
    ButtonCaptionsIDs(ButtonCaptionsNum) = ID
  End If
  
  ToolBarButton_AddString = ID
End Function
