Attribute VB_Name = "ToolTipDeclarations"
Option Explicit

'==================================================================
'
' ToolTip Declarations
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================



'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?

'------------------------------------------------------------------------
' Declarations

Public Const TOOLTIPS_CLASS = "tooltips_class32"

Public Enum ToolTipMessages
  TTM_ACTIVATE = (WM_USER + 1)
  TTM_SETDELAYTIME = (WM_USER + 3)
  TTM_ADDTOOLA = (WM_USER + 4)
  TTM_ADDTOOLW = (WM_USER + 50)
  TTM_DELTOOLA = (WM_USER + 5)
  TTM_DELTOOLW = (WM_USER + 51)
  TTM_NEWTOOLRECTA = (WM_USER + 6)
  TTM_NEWTOOLRECTW = (WM_USER + 52)
  TTM_RELAYEVENT = (WM_USER + 7)
  
  TTM_GETTOOLINFOA = (WM_USER + 8)
  TTM_GETTOOLINFOW = (WM_USER + 53)
  
  TTM_SETTOOLINFOA = (WM_USER + 9)
  TTM_SETTOOLINFOW = (WM_USER + 54)
  
  TTM_HITTESTA = (WM_USER + 10)
  TTM_HITTESTW = (WM_USER + 55)
  TTM_GETTEXTA = (WM_USER + 11)
  TTM_GETTEXTW = (WM_USER + 56)
  TTM_UPDATETIPTEXTA = (WM_USER + 12)
  TTM_UPDATETIPTEXTW = (WM_USER + 57)
  TTM_GETTOOLCOUNT = (WM_USER + 13)
  TTM_ENUMTOOLSA = (WM_USER + 14)
  TTM_ENUMTOOLSW = (WM_USER + 58)
  TTM_GETCURRENTTOOLA = (WM_USER + 15)
  TTM_GETCURRENTTOOLW = (WM_USER + 59)
  TTM_WINDOWFROMPOINT = (WM_USER + 16)
#If (WIN32_IE >= IE3) Then
  TTM_TRACKACTIVATE = (WM_USER + 17)       ' wParam = TRUE/FALSE start end  lparam = LPTOOLINFO
  TTM_TRACKPOSITION = (WM_USER + 18)       ' lParam = dwPos
  TTM_SETTIPBKCOLOR = (WM_USER + 19)
  TTM_SETTIPTEXTCOLOR = (WM_USER + 20)
  TTM_GETDELAYTIME = (WM_USER + 21)
  TTM_GETTIPBKCOLOR = (WM_USER + 22)
  TTM_GETTIPTEXTCOLOR = (WM_USER + 23)
  TTM_SETMAXTIPWIDTH = (WM_USER + 24)
  TTM_GETMAXTIPWIDTH = (WM_USER + 25)
  TTM_SETMARGIN = (WM_USER + 26)           ' lParam = lprc
  TTM_GETMARGIN = (WM_USER + 27)           ' lParam = lprc
  TTM_POP = (WM_USER + 28)
#End If
#If (WIN32_IE >= IE4) Then
  TTM_UPDATE = (WM_USER + 29)
#End If
#If (WIN32_IE >= IE5) Then
  TTM_GETBUBBLESIZE = (WM_USER + 30)
  TTM_ADJUSTRECT = (WM_USER + 31)
  TTM_SETTITLEA = (WM_USER + 32)           ' wParam = TTI_*, lParam = char* szTitle
  TTM_SETTITLEW = (WM_USER + 33)           ' wParam = TTI_*, lParam = wchar* szTitle
#End If
#If UNICODE Then
  TTM_ADDTOOL = TTM_ADDTOOLW
  TTM_DELTOOL = TTM_DELTOOLW
  TTM_NEWTOOLRECT = TTM_NEWTOOLRECTW
  TTM_GETTOOLINFO = TTM_GETTOOLINFOW
  TTM_SETTOOLINFO = TTM_SETTOOLINFOW
  TTM_HITTEST = TTM_HITTESTW
  TTM_GETTEXT = TTM_GETTEXTW
  TTM_UPDATETIPTEXT = TTM_UPDATETIPTEXTW
  TTM_ENUMTOOLS = TTM_ENUMTOOLSW
  TTM_GETCURRENTTOOL = TTM_GETCURRENTTOOLW
#If (WIN32_IE >= IE5) Then
    TTM_SETTITLE = TTM_SETTITLEW
#End If
#Else
  TTM_ADDTOOL = TTM_ADDTOOLA
  TTM_DELTOOL = TTM_DELTOOLA
  TTM_NEWTOOLRECT = TTM_NEWTOOLRECTA
  TTM_GETTOOLINFO = TTM_GETTOOLINFOA
  TTM_SETTOOLINFO = TTM_SETTOOLINFOA
  TTM_HITTEST = TTM_HITTESTA
  TTM_GETTEXT = TTM_GETTEXTA
  TTM_UPDATETIPTEXT = TTM_UPDATETIPTEXTA
  TTM_ENUMTOOLS = TTM_ENUMTOOLSA
  TTM_GETCURRENTTOOL = TTM_GETCURRENTTOOLA
#If (WIN32_IE >= IE5) Then
    TTM_SETTITLE = TTM_SETTITLEA
#End If
#End If
End Enum

Public Enum ToolTipNotifications
  TTN_GETDISPINFOA = (TTN_FIRST - 0)
  TTN_GETDISPINFOW = (TTN_FIRST - 10)
  TTN_SHOW = (TTN_FIRST - 1)
  TTN_POP = (TTN_FIRST - 2)
  
  TTN_NEEDTEXTA = TTN_GETDISPINFOA
  TTN_NEEDTEXTW = TTN_GETDISPINFOW
  
#If UNICODE Then
  TTN_NEEDTEXT = TTN_NEEDTEXTW
  TTN_GETDISPINFO = TTN_GETDISPINFOW
#Else
  TTN_NEEDTEXT = TTN_NEEDTEXTA
  TTN_GETDISPINFO = TTN_GETDISPINFOA
#End If
End Enum

Public Enum ToolTipStyles
  TTS_ALWAYSTIP = &H1
  TTS_NOPREFIX = &H2
#If (WIN32_IE >= IE5) Then
  TTS_NOANIMATE = &H10
  TTS_NOFADE = &H20
  TTS_BALLOON = &H40
#End If
End Enum

Public Enum ToolTipFlags
  TTF_IDISHWND = &H1
  TTF_CENTERTIP = &H2
  TTF_RTLREADING = &H4
  TTF_SUBCLASS = &H10
#If (WIN32_IE >= IE3) Then
  TTF_TRACK = &H20
  TTF_ABSOLUTE = &H80
  TTF_TRANSPARENT = &H100
  TTF_DI_SETITEM = &H8000       ' valid only on the TTN_NEEDTEXT callback
#End If
End Enum

Public Enum ToolTipDelayTimeFlags
  TTDT_AUTOMATIC = 0
  TTDT_RESHOW = 1
  TTDT_AUTOPOP = 2
  TTDT_INITIAL = 3
End Enum

Public Enum ToolTipIcons
  TTI_NONE = 0
  TTI_INFO = 1
  TTI_WARNING = 2
  TTI_ERROR = 3
End Enum

#If (WIN32_IE >= IE4) Then
Public Const INFOTIPSIZE = 1024 ' ToolTip size for tooltip callbacks (not NEEDTEXT)
#End If

Public Type NMTTDISPINFO
  hdr As NMHDR
  lpszText As Long
  szText(0 To 79) As Byte
  hInst As Long
  uFlags As Long
  lParam As Long
End Type

Public Type TT_HITTESTINFO
  hWnd As Long
  pt As POINTAPI
  TI As NMTTDISPINFO
End Type

#If (WIN32_IE >= IE3) Then
  Public Type TOOLINFO
    cbSize As Long
    uFlags As Long
    hWnd As Long
    uId As Long
    rct As RECT
    hInst As Long
    lpszText As String 'lpsz/long (Long-Pointer to zero-terminated string)
  End Type
#End If
